#ex4_luan.R
#Luan Sayeg Michelazzo
#NUSP 7590930
#luan50@gmail.com
################################## EX 4.2 ############################
#atribui os dados na variavel cervejas
cervejas=c("chope","lata","garrafa","chope","garrafa", "garrafa",
             "lata","lata","nenhuma","lata","garrafa","garrafa", 
             "garrafa","lata","lata","lata","garrafa","lata",
             "chope","nenhuma", "garrafa","garrafa","garrafa",
             "chope","garrafa","garrafa","chope","garrafa","lata",
             "lata")
#fatoriza a variavel cervejas
cervejas.f= factor(cervejas)
#tranforma em tabela
cervejas.t= table(cervejas.f)
#parametros graficos
par(mfrow = c(1,2))
#cria o barplot
barplot(cervejas.t)
#cria o dot chart a partir da tabela e dos fatores
dotchart(as.numeric(cervejas.t),label=cervejas.f)

#O dotchart tem uma razao maior dado/tinta

################################## EX 4.3 ############################
#carrega o .csv
caixeta = read.csv("caixeta.csv", as.is=T)
#transforma circunferencia em diametro
caixeta$dap=caixeta$cap/pi
#hitograma dos DAPs (CAPS?????)
hist(caixeta$dap)
par(mfrow=c(1,3))
#retiras os dados de arvore por local
ar.chau = caixeta$h[caixeta$local == "chauas"]
ar.jure = caixeta$h[caixeta$local == "jureia"]
ar.reti = caixeta$h[caixeta$local == "retiro"]
#cria os histogramas
hist(ar.chau)
hist(ar.reti)
hist(ar.jure)

#Sim, ha diferenca
################################## EX 4.4 ############################
#carrega o .csv
egrandis = read.csv("egrandis.csv",sep=";")
#boxplot de dap por regiao
boxplot(egrandis$dap~egrandis$regiao)
#boxplot de dap por rota??o
boxplot(egrandis$dap~egrandis$rotacao)
#cria o grafico quantil-quantil
qqnorm(egrandis$ht,pch=20,frame=F)
#cria a linha normal de referencia
qqline(egrandis$ht,col="red",lwd=2)

################################## EX 4.5 ############################
#carrega o .csv
caixeta = read.csv("caixeta.csv", as.is=T)
#cap p/ dap
caixeta$dap = caixeta$cap/pi
#calculo da area basal
caixeta$ab = pi * (caixeta$dap/2)^2
#so os dados de T. cassinoides
tc = caixeta[caixeta$especie == "Tabebuia cassinoides",]
#faz as somas das areas basais preservando os locais
soma.ab = aggregate(tc$ab,list(tc$arvore,tc$local),sum)
#retorna a area basal para dap
dap.ar = 2 * sqrt(soma.ab[,3]/pi)
#retira as alturas preservando os locais
h.ar = aggregate(tc$h,list(tc$arvore,tc$local),mean)
#Data frame dos dados extraidos e calculados
TC=data.frame(h.ar,dap.ar)
#nomes das colunas
cn=c("linha","local","h","dap")
colnames(TC) = cn
#parametros graficos
par(mfrow=c(1,3))
#plota o dap em funcao da altura apenas nos locais especificados no subset
with(subset(TC,TC$local=="chauas"),plot(dap~h,xlab=""))
#Adiciona o texto ao grafico
mtext("Chauas")
with(subset(TC,TC$local=="jureia"),plot(dap~h,ylab=""),sub="Jureia")
mtext("Jureia")
with(subset(TC,TC$local=="retiro"),plot(dap~h,xlab="",ylab=""),sub="Retiro")
mtext("Retiro")
#O mesmo para a funcao scatter.smooth
with(subset(TC,TC$local=="chauas"),scatter.smooth(dap~h,xlab=""))
mtext("Chauas")
with(subset(TC,TC$local=="jureia"),scatter.smooth(dap~h,ylab=""),sub="Jureia")
mtext("Jureia")
with(subset(TC,TC$local=="retiro"),scatter.smooth(dap~h,xlab="",ylab=""),sub="Retiro")
mtext("Retiro")

#carrega a biblioteca
library("lattice")
#aplica a funcao xyplot
xyplot(dap~h|local, data=tc, xlab="DAP", ylab="h")


