#ex5_luan.R
#Luan Sayeg Michelazzo
#NUSP 7590930
#luan50@gmail.com

####################### EX 5.1 ######################
#carrega o .csv
saligna = read.csv(file = "esalingna.csv",sep=",")
#atribui os nomes dos eixos as variáveis "xlabel" e "ylabel"
xlabel = "Diametro na altura\ndo peito"
ylabel = "Altura (m)"
#cria o device png com todos parametros no default
png(filename= "saligna.png")
#atribui os parametros gráficos
#cex: tamanho do ponto; cex.lab: tamanho dos rotulos dos
#eixos; cex.axis: tamanho dos rotulos dos marcadores nos 
#eixos; cex.main: tamanho do titulo; tcl: tamanho e posição
#dos marcadores nos eixos; las: orientação dos rótulos e
#marcadores de eixo; bty: eixos visiveis
par(cex=1.4,cex.lab=1.7,cex.axis=1.5,cex.main=1.8, tcl=0.3,las=1,bty="l")
#chama o gráfico com a funcao "plot()"
plot(saligna$dap,saligna$ht,pch=19,col="red",main="Eucalypthus saligna",xlab=xlabel,ylab=ylabel)
#fecha o device e salva os conteudos do grafico no .png
dev.off()

####################### EX 5.2 ######################
#carrega o .csv
saligna = read.csv(file = "esalingna.csv",sep=",")
#retira as variaveis do data.frame e fatoriza o talhao
dap = saligna$dap
talhao = factor(saligna$talhao)
#tira as médias do DAP por talhao
mean.dap = aggregate(dap,list(talhao),mean)
#talhoes
talha.n = mean.dap[,1]
talha.f = mean.dap[,1]
talha.n = c(talha.n)
#medias e desvio padrão dos daps por talhao
mean.dap = mean.dap[,2]
sd.dap = aggregate(dap,list(talhao),sd)
sd.dap = sd.dap[,2]
#cria o device png com todos parametros no default
png(filename= "ex5_2.png")
#atribui os parametros gráficos
#mfrow: separa em uma matriz de graficos; mar: margens
par(mfrow=c(1,2),
	cex=1,cex.lab=1,cex.axis=1,cex.main=1,
	mar= c(4,4,4,1),
	tcl=0.3,las=1,bty="l")
#boxplot dos daps em função dos talhoes
boxplot(dap~talhao,ylim=c(5,22),xlab="",ylab="")
#Rotulo do eixo Y
mtext("DAP",side=2,line=2, at=12.5, padj=0)
#plota os as medias de dap por talhao
plot(talha.n,mean.dap,pch=19,ylim=c(5,22),xlab="",ylab="",xaxt="n")
axis(side=1,at=talha.n,labels = talha.f)
#plota os pontos na media +/- um desvio padrao

points(talha.f,mean.dap+sd.dap,pch="-",cex=3)
points(talha.f,mean.dap-sd.dap,pch="-",cex=3)
#cria o segmento entre os pontos anteriores
segments(talha.n,mean.dap-sd.dap,talha.n,mean.dap+sd.dap)
#cria o rótulo do eixo X
mtext("Talhao",side=1,line=2, at=-0.5)
#fecha o device e salva os conteudos do grafico no .png
dev.off()

####################### EX 5.3 ######################
#carrega o .csv
file=read.csv("estearquivo.csv",sep=",")
#atribui as variaveis altura e largura da imagem
altura = 554
largura = 1009
#cria o device png com todos parametros no default
png("ex5_3.png",height=554,width=1009)
#medias de y1 em por y2
mean.y2=aggregate(file$y2,list(file$y1),mean)
#Fatoriza y2 de acordo com a imagem
lvl.y2 = factor(file$y2,labels=c("Small",
				"Medium\nedge",
				"Medium\ninterior",
				"Large\nedge",
				"Large\ninterior",
				"Control"))
#parametros graficos
par(mfrow=c(1,2),tcl=0.3,las=0,bty="l",family="serif")
#plota os pontos x1 em função de x2
plot(file$x1,file$x2,
	xlim=c(0.4,2.5),ylim=c(-0.1,3.1),
	xlab="Log(Patch size)(ha)", ylab="",
	pch=17)
#cria a letra "a"
text(labels="a",x=2.5,y=3)
#rotulo do eixo y
mtext("Euclidean distances", at=1.5 ,cex=1.8,line=2.3,side=2)
#cria o modelo linear a partir dos dados
modelo = lm(file$y1~file$x1)
#plota a linha
abline(modelo,cex=3)
#cria a variavel ast com asteriscos, como na imagem
ast=c("*","*","**","*","***")
ast.posx=c(1,2,3,4,5)
ast.posy=c(rep(3,5))
#cria o segundo grafico, de boxplot
boxplot(file$x2~lvl.y2,outline=F,ylim=c(-0.1,3.1),xlab="",ylab="")
#plota os asteriscos
text(labels=ast,x=ast.posx,y=ast.posy)
# cria a letra "b" no gráfico
text(labels="b",x=6.3,y=3)
#fecha o device e salva os conteudos do grafico no .png
dev.off()