bebes <- read.table("babies2.csv", header= TRUE, as.is = TRUE, sep= " ")

#Retira outliers
bebes = bebes[bebes$bwt != 999,]
bebes = bebes[bebes$gestation != 999,]
bebes = bebes[bebes$parity != 9,]
bebes = bebes[bebes$age != 99,]
bebes = bebes[bebes$height != 99,]
bebes = bebes[bebes$weight != 999,]
bebes = bebes[bebes$smoke != 9,]

#modelo 01 (peso do bebe ~ tempo de gestacao)
lm01 = lm(bwt ~ gestation, data=bebes, model = F)
#coeficientes do modelo 01
cf.01 = coef(lm01)

#retira o peso do bebe do dataframe
bwt = bebes$bwt
ges = bebes$gestation
#media
bwt.mean = mean(bwt)
ges.mean = mean(ges)
#variancia
wt.var = var(bwt)
#comprimento
wt.n = length(bwt)
#desvios da media ao quadrado
ges.sq = (ges - ges.mean)^2
#media da gestacao
g.mean = mean(bebes$gestation)
#soma dos desvios da media ao quadrado (peso de bebes)
SSX = sum(ges.sq)
#vetor de gestacao criado com 100 valores entre
x100 = seq(min(bebes$gestation), max(bebes$gestation), length = 100)
#teste t com 95% de confianca
tt = qt(0.025, wt.n-2)
#erro padrao a partir dos ultimos resultados criados/calculados
se = sqrt(wt.var * (1/wt.n + (x100-g.mean)^2/SSX))
#desvio inferior para o intervalo de confianca
ic.low = se*tt
#desvio superior para o intervalo de confianca
ic.upp = se* (-tt)
#adiciona o desvio na reta com os coeficientes do modelo
lwr = cf.01[1] + cf.01[2]*x100 + ic.low
upp = cf.01[1] + cf.01[2]*x100 + ic.upp
#plota os pontos 
plot(bwt ~ gestation,data=bebes,pch = 16,col = rgb(0,0,1,0.3))
#plota a linha do modelo
abline(lm01)
#plota o poligono com os intervaos de confianca
polygon(c(x100,rev(x100)),c(upp,rev(lwr)), col = rgb(0,1,0,0.5),border =F)


#Galileu
#carrega os dados
init.h = c(600, 700, 800, 950, 1100, 1300, 1500)
h.d = c(253, 337, 395, 451, 495, 534, 573)

plot(h.d ~init.h)
gal01 = lm(h.d ~ init.h)
gal02 = update(gal01, . ~ . + I(init.h^2))
gal03 = update(gal02, . ~ . + I(init.h^3))

anova(gal02,gal03)
#Sim, galileu estava certo. O melhor modelo é o polinomio
# de terceiro grau, pois e o qe gera os menores residuos

#RECEM-NASCIDOS

bebes$parity = as.factor(bebes$parity)
#calcular o IMC para diminuir o numero de variaveis
bebes$imc = bebes$weight/bebes$height^2


bbful = lm(bwt ~ gestation+parity+age+imc+smoke, data=bebes)
bb01 = update(bbful, .~. -age, data=bebes)
anova(bb01,bbful)
bb02 = update(bb01, .~. -imc, data=bebes)
anova(bb02,bb01)


#segundo o modelo sem interações, o melhor modelo e o que considera o tempo de gestacao
#paridade e habitos de fumo

