eutad = read.table("palmadulto.txt", sep="\t",header=TRUE)

dist = matrix(NA, ncol = d, nrow = d)
dist

for(i in 1:(d-1)){
  for(j in (i+1):d)
  {
    difx2=(eutad$gx[i]-eutad$gx[j])^2
    dify2=(eutad$gy[i]-eutad$gy[j])^2
    dist[i,j]<-sqrt(difx2 + dify2)
    dist[j,i]<-sqrt(difx2 + dify2)
  }          
}
str(dist)
head(dist)
tail(dist)

(nn<-apply(dist, 1, min, na.rm=TRUE))
(mnn<-mean(nn))


nsim = 1000
#cria vetor resultado com 1000 NA's
resultado = rep(NA, nsim)
#atribui a media dos dados os primeiro resultado
resultado[1] = mnn
#d = numero de observacoes
d = dim(eutad)[1]

#comea o loop com k de um a nsim-1 simulacoes
for (k in 2:nsim){
  
  #cria as posicoes simuladas
  #xsim = sample(seq(0,320,by=0.1),dim(eutad)[1])
  #ysim = sample(seq(0,320,by=0.1),dim(eutad)[1])
  xsim = round(runif(d,0,320),1)
  ysim = round(runif(d,0,320),1)
  #cria a matriz distantancia simulada com NA's
  dist.sim = matrix(NA, ncol=102, nrow=102)
  
  #loop para preencher a matriz
  #somatoria  de d*(d-1) vezes a distancia euclidiana entre as posicoes simuladas
  for (l in 1:(d-1)){
    for (m in (l+1):d){
      #calcula as distancias
      difx2.sim = (xsim[l] - xsim[m])^2
      dify2.sim = (ysim[l] - ysim[m])^2
      #preenche o triangulo superior e inferior da matriz
      dist.sim[l,m] <- sqrt(difx2.sim + dify2.sim)
      dist.sim[m,l] <- sqrt(difx2.sim + dify2.sim)
      
    }
    #atribui as medias das minimas distancias calculadas a simulacao k
    resultado[k] = mean(apply(dist.sim, 1, min, na.rm=T),na.rm=T)
  }
}
#histograma e linha vermelha representando a media dos dados
hist(resultado)
abline(v=mnn, col="red")
#calculo da probabilidade 
prob = sum(resultado <= mnn)/nsim
prob


#Exercicio 2
bobr = read.csv("bodybrain.csv", sep=";",header=T)
#remove NA's
bobr = na.omit(bobr)
#calcula o logaritimo dos dados e as medias
body = log(bobr$body)
body.m =  mean(body)
brain = log(bobr$brain)
brain.m = mean(brain)
#calcula a inclinacao do modelo
beta0 = sum((body - body.m)*(brain - brain.m))/sum((body - body.m)^2)
beta0

nsim =1000
#cria vetor com NA's
betan = rep(NA,nsim)
#atribui valor da inclinacao beta ao primeiro resultado
betan[1] = beta0
#loop com 1000 simulacoes
for (i in 2:nsim){
  #retira resultados aleatoriamente dos dados
	sim_brain = sample(brain,replace = T)
	#calcula os coeficientes simulados e os coloca na posicao i
	betan[i] = sum((body - body.m)*(sim_brain - mean(sim_brain)))/sum((body - body.m)^2)
	}
#histograma e linha represntando os dados
hist(betan)
abline(v=beta0,col="red")
#probabilidade do coeficiente beta dos dados ser aleatorio
prob = sum(betan >= beta0)/nsim
prob
