#####EXERCCIO 7B
######################################
#7b. Exerccios de Regresso Mltipla

bebes<- read.table("http://ecologia.ib.usp.br/bie5782/lib/exe/fetch.php?media=dados:babies.txt", sep=" ", header=T, as.is= T )

#para remover as linhas com NA 
length(bebes[bebes == c(99,999)])
bebes[bebes==99] <- NA
bebes[bebes==999] <- NA
summary(bebes)

bebes<- na.omit(bebes)
bebes

lm.bebes<-lm(bebes$bwt~bebes$gestation)
#plot(lm.bebes)
anova(lm.bebes)

x<-seq(min(bebes$gestation)-10,
           max(bebes$gestation)+10, 
           length.out =100)

SSX<-sum((bebes$gestation-mean(bebes$gestation))^2)
n<-length(bebes$bwt)
mean.x<-mean(bebes$gestation)
s2<- var(bebes$bwt)

se.y<- sqrt(s2*((1/n)+((x-mean.x)^2/SSX)))
se.y

y<-lm.bebes$coefficients[2]*x+lm.bebes$coefficients[1]

ic.max.y<-y+se.y
ic.min.y<-y-se.y

###Para plotar o grfico

par(c(1,1),mar=c(4,4,2,2),   
    cex.lab=1.5, 
    cex.axis=1.2, 
    las=1, 
    bg = "gray70", 
    bty="n")


plot(NA, 
     type="n", 
     axes = FALSE, 
     ann = FALSE,
     xlim = range(bebes$gestation), 
     ylim = range(bebes$bwt)
     ) 


points(bebes$bwt~bebes$gestation,
       pch = 19,
       cex= 1.5,
       col = rgb(0,0,1, 0.4))

axis(1)
axis(2)
mtext("Tempo de gestao (dias)", 1,  line=2.5, cex = 1.7)
mtext("Peso do beb (kg)", 2, line=2.5, cex = 1.7, las = 0)

abline(lm.bebes, col="red")

polygon(c(rev(x), x), 
        c(rev(ic.max.y), ic.min.y),
        col=rgb(0,0,0,.2),
        border= NA)
        

########################################
#Galileu estava Certo?
########################################

#  Partindo do tutorial Ajuste de Polinmios, avalie se um polinmio de terceiro grau  um melhor modelo para descrever os dados do experimento de Galileu. A equao para este modelo :
  
init.h = c(600, 700, 800, 950, 1100, 1300, 1500)
h.d = c(253, 337, 395, 451, 495, 534, 573)
mod1 <- lm(h.d~init.h)
mod2 <- update(mod1,.~. +I(init.h^2)) 
mod3 <- update(mod2,.~.+I(init.h^3))
anova(mod2,mod3)

summary(mod1)
summary(mod2)
summary(mod3)




####################################
#  Massa de Recm-Nascidos
####################################

#Utilize todas as variveis disponveis no conjunto de dados Massa ao Nascer e Dados da me para chegar ao melhor modelo de previso da massa de bebs ao nascer.


# avaliao da linearidade
pairs(bebes, panel= panel.smooth)#so lineares, no  necessrio colocar os I(var^2)

# analise de correlao 
panel.cor <- function(x, y, digits = 2, prefix = "", cex.cor, ...)
{
  usr <- par("usr"); on.exit(par(usr))
  par(usr = c(0, 1, 0, 1))
  r <- abs(cor(x, y))
  txt <- format(c(r, 0.123456789), digits = digits)[1]
  txt <- paste0(prefix, txt)
  if(missing(cex.cor)) cex.cor <- 0.8/strwidth(txt)
  text(0.5, 0.5, txt, cex = cex.cor * r)
}
pairs(bebes, upper.panel= panel.cor, lower.panel = panel.smooth)

#No h forte correlao entre as variveis, por isso foram mantidas todas as variaveis e relaes na anlise a seguir.

#modelo completo
bebefull<- lm(bebes$bwt~
                bebes$gestation* 
                bebes$parity*
                bebes$age*
                bebes$height*
                bebes$weight*
                bebes$smoke
              )

summfull<- summary(bebefull)
summfull


#modelo nulo
bebenull<- lm(bebes$bwt~1)

#analise dos modelos
anova(bebefull, bebenull)# modelo completo  mais adequado que o modelo nulo para explicar a variao de peso em bebes (logico...)

#removendo a relao das seis variaveis 
bebe.6 <-update(bebefull, .~.  -bebes$gestation:bebes$parity:bebes$age:bebes$height:bebes$weight:bebes$smoke)
anova(bebefull,bebe.6)

step(bebefull, direction="forward") #a relao de 6 fatores  <0.02, sendo significativa, o que indica que o modelo full  melhor que o modelo sem a relao de seis fatores, removida em bebe.6, para explicar a variao do pesos de bebes.


anv.bebefull<- anova(bebefull)

#Para seleo do modelo foram removidas todos os fatores cujo p-valor, pela Anova do modelo full, fossem maiores que 0.1 (identificada sem simbolos " ")
lm1<-lm(bebes$bwt~bebes$gestation+
          bebes$parity+
          bebes$height+
          bebes$weight+
          bebes$smoke+
          bebes$gestation:bebes$age+
          bebes$gestation:bebes$weight+
          bebes$gestation:bebes$smoke+
          bebes$parity:bebes$smoke+
          bebes$weight:bebes$smoke+
          bebes$parity:bebes$age:bebes$height:bebes$weight+
          bebes$gestation:bebes$parity:bebes$age:bebes$height:bebes$weight:bebes$smoke)

anova(bebefull, lm1) #p-valor no significativo, escolha pelo modelo mais simples(lm1)

step(lm1, direction = "both")

#para o proximo modelo foram removidas as variaveis identificadas na Anova do modelo completo com p-valor entre 0.05 e 0.1 (identificadas pelo simbolo ".")
lm2<-lm(bebes$bwt~bebes$gestation+
          bebes$parity+
          bebes$height+
          bebes$weight+
          bebes$smoke+
          bebes$gestation:bebes$age+
          bebes$gestation:bebes$weight+
          bebes$gestation:bebes$smoke+
          bebes$parity:bebes$smoke+
          bebes$gestation:bebes$parity:bebes$age:bebes$height:bebes$weight:bebes$smoke)

anova(bebefull, lm2) ##p-valor no significativo, escolha pelo modelo mais simples(lm2)

#para o proximo modelo foram removidas as variaveis identificadas pela ANOVA do modelo completo com p-valor entre 0.01 e 0.05 (identificadas por "*")
lm3<-lm(bebes$bwt~bebes$gestation+
          bebes$parity+
          bebes$height+
          bebes$smoke+
          bebes$gestation:bebes$age+
          bebes$gestation:bebes$smoke+
          bebes$parity:bebes$smoke)
anova(bebefull, lm3)##p-valor no significativo, escolha pelo modelo mais simples(lm3)

#para o proximo modelo foram removidas as variaveis identificadas pela ANOVA do modelo completo com p-valor entre 0.001 e 0.01 (identificadas por "**")
lm4<-lm(bebes$bwt~bebes$gestation+
          bebes$height+
          bebes$smoke+
          bebes$gestation:bebes$age+
          bebes$gestation:bebes$smoke)
anova(bebefull, lm4) ##p-valor significativo, escolha pelo modelo complexo. Nesse caso, seria o full. 
#mas ao comparar o modelo cheio (bebefull com o lm3, mantendo o lm3)

lm5<-lm(bebes$bwt~bebes$gestation+
          #bebes$parity+
          bebes$height+
          bebes$smoke+
          #bebes$gestation:bebes$age+
          bebes$gestation:bebes$smoke+
          bebes$parity:bebes$smoke)
anova(bebefull, lm5)


#modelo minimo adequado
summary(lm5)# todos os p-valor so significativos

AIC(bebefull,lm1, lm2, lm3, lm4, lm5) #o modelo 5 apresenta o menor AIC e menor df, sendo portanto o modelo que explica a variao de peso de bebes, com o menor numero de variaveis e de relaes. 





