mudas<- read.table("http://ecologia.ib.usp.br/bie5782/lib/exe/fetch.php?media=dados:altura-mudas.csv", header = T, sep=",", dec=".")
str(mudas)

#RESPOSTAS S QUESTES:
###Varivel medida: $altura
###Fator de interesse: $substrato
###Cada dado  replicado 6x
##### Para a construo dos grficos foram usados apenas os valores referentes a Tamboril, uma vez que o enunciado da questo indicava que as analises deveriam se referir  espcie.

tamboril<- mudas[mudas$especie=="tamboril",]
mean.total<- mean(tamboril$altura)
mean.gr<- aggregate(tamboril$altura, by=list(tamboril$substrato), mean)
colnames(mean.gr)<-c("susbtrato", "mean.subs")
str(mean.gr)

plot(c(1:length(tamboril$altura)),
       tamboril$altura, 
     pch=14+c(tamboril$substrato),
       col=tamboril$substrato,
       xlab= "",
       ylab="Altura (m)", 
      main= "Variao total")

abline(h= mean.total)

segments(y0=tamboril$altura, 
         x0=c(1:length(tamboril$altura)),
         y1=rep(mean.total,length(tamboril$altura)), 
         x1=c(1:length(tamboril$altura)),
         col=tamboril$substrato,
        )


#Variao intra-grupos
plot(c(1:length(tamboril$altura)),
    tamboril$altura, 
     pch=14+c(tamboril$substrato),
     col=tamboril$substrato,
     xlab= "",
     ylab="Altura (m)", 
     main= "Variao intragrupos"
     )

segments(x0= round(seq(1,59, by=6)),
         x1= seq(6,60,by=6 ),
         y0= mean.gr$mean.subs, 
         y1= mean.gr$mean.subs, 
         col= c(1:10))

for (i in 1:60)
{
  lines(c(i,i), 
        c(tamboril$altura[i],
          (rep(mean.gr$mean.subs, each = 6)[i])),
           col=tamboril$substrato[i])
}

### entre-grupos

plot(x= c(1:length(tamboril$altura)),
     y= rep(mean.gr$mean.subs, each=6), 
     pch=14+c(tamboril$substrato),
     col=tamboril$substrato,
     xlab= "",
     ylab="Altura (m)", 
     main= "Variao intragrupos"
)

abline(h= mean.total) #media geral

for (i in 1:60)
{
  lines(c(i,i), 
        c((rep(mean.gr$mean.subs, each = 6)[i]), mean.total),
        col=tamboril$substrato[i])
}  

########

tamboril

ss.intra.gr<-rep(NA,10)
for (i in 1:10)
{ 
  ss.intra.gr[i]<- sum((tamboril$altura[tamboril$substrato==i]
                    -rep(mean.gr$mean.subs[i],each=6))^2)

  }
 
ss.intra<- sum(ss.intra.gr)

ss.entre<- 6*sum((mean.gr$mean.subs-mean.total)^2)### multiplica pelo numero de replicas *6
ss.total<- sum(ss.intra,ss.entre)
gl.total<- 59
gl.intra<- 60-10
gl.entre<- 9

ms.intra<- ss.intra/gl.intra
ms.entre<- ss.entre/gl.entre
razao<-ms.entre/ms.intra
prob<-pf(razao,gl.entre, gl.intra)
porc<-1-prob


