##7b. Exerccios de Regresso Mltipla
#Uma estimativa da incerteza na previso do modelo
bebes <- read.table("babies.txt", header= TRUE, as.is = TRUE, sep= "", dec=".")

#Construa esse grfico para avaliar a incerteza do modelo para a relao peso do 
#beb (kg) ~ tempo de gestao (dias) dos dados Massa ao Nascer e Dados da me, usando 
#a frmula acima para estimar o intervalo de confiana de 95%.
str(bebes)
head(bebes)
tail(bebes)
summary(bebes)
#escluir os dados faltantes (999)
summary(bebes$bwt)
summary(bebes$gestation) #tirar
summary(bebes$parity) 
summary(bebes$age)#tirar
summary(bebes$height)#tirar
summary(bebes$smoke) #tirar
summary(bebes$weight) #tirar


bebes2 <- data.frame(subset(x=bebes,bebes$gestation<999&bebes$weight<999&bebes$age<99&bebes$height<99&
                       bebes$smoke<9))
summary(bebes2) 

#calcular o erro padro da previso do modelo
#modelo do peso do beb (kg) ~ tempo de gestao (dias)
m <- lm(bwt ~ gestation, data=bebes2)
summary(m)
anova(m)

#x : valor da varivel preditora para o qual se quer estimar o erro padro
summary(bebes2$gestation)
x <- seq(min(bebes2$gestation)-30, max(bebes2$gestation)+30, length=100) #criando sequencia para eixo x (tive que colocar +- 30 para ajustar o intervalo de confiana)
#criando sequencia para eixo x
#SSX : soma dos desvios quadrticos dos valores de x observados = 65450
xmedia <- mean(x) #x : mdia dos valores de x observados
difx <- (x-xmedia)^2
ssx <- sum((bebes2$gestation-mean(bebes2$gestation))^2)
#s2 : varincia dos valores de y observados
vary <- var(bebes2$bwt)
#n: nmero de observaes =1174
n <-length(bebes2$bwt)


erro.padrao = sqrt(vary*((1/n)+((x-xmedia)^2/ssx)))
t = qt(0.025,n-2,lower.tail = F)
#ou qt(0.975,n-2,)

intervalo_confianca = erro.padrao*t

ypreditos = predict(m, newdata = data.frame(gestation=x))

#grafico
par(cex.axis=1.1, cex.lab=1.3)
grafico <- plot(bebes2$bwt ~ bebes2$gestation, ylab="Peso dos bebs (kg)",xlab="Tempo de gestao (dias)", bty="l", pch=16, col="blue", cex=0.5, tcl=0.3, las=1)
abline(m, col="red")

#Fazendo o grafico com o intervalo de confianca de 95% dos preditos
polygon(c(rev(x), x), c(rev(ypreditos-intervalo_confianca), ypreditos+intervalo_confianca), col=rgb(0,0,0, 0.3))

#Sem calcular tudo na mao ( mas tem que colocar interval='confidence' no predict)
#polygon(c(rev(x), x), c(rev(ypreditos[,2]), ypreditos[,3]), col=rgb(0,0,0, 0.3))

##Galileu estava Certo?
#Partindo do tutorial Ajuste de Polinmios, avalie se um 
#polinmio de terceiro grau  um melhor modelo para 
#descrever os dados do experimento de Galileu. 

#As alturas de lanamentos e as distncias percorridas
#obtidas por Galileu so:
  
init.h = c(600, 700, 800, 950, 1100, 1300, 1500)
h.d = c(253, 337, 395, 451, 495, 534, 573)
  
#Vamos fazer o grfico de disperso:
plot(h.d~init.h)

mod1 <- lm(h.d~init.h)
mod2 <- update(mod1,.~. +I(init.h^2))
mod3 <- update(mod2,.~.+I(init.h^3))
anova(mod1,mod2)
#O modelo 2 (parbola) descreve melhor os dados. 
anova(mod2,mod3)
#O modelo 3 (parbola) descreve melhor os dados. 
#O polinmio de terceiro grau  um melhor modelo para 
#descrever os dados do experimento de Galileu.

abline(mod1)

cf.m2 <- coef(mod2)
curve(cf.m2[1]+cf.m2[2]*x+cf.m2[3]*x^2, add=T, lty=2)

cf.m3 <- coef(mod3)
curve(cf.m3[1]+cf.m3[2]*x+cf.m3[3]*x^2+cf.m3[4]*x^3, add=T, lty=2, col="purple")

##Massa de Recm-Nascidos
bebes <- read.table("babies.txt", header= TRUE, as.is = TRUE, sep= "", dec=".")
bebes2 <- data.frame(subset(x=bebes,bebes$gestation<999&bebes$weight<999&bebes$age<99&bebes$height<99&
                              bebes$smoke<9))
#Utilize todas as variveis disponveis no conjunto de 
#dados "Massa ao Nascer e Dados da me" para chegar ao 
#melhor modelo de previso da massa de bebs ao nascer.

#Vaiaveis
summary(bebes$bwt)
summary(bebes$gestation) 
summary(bebes$parity) 
summary(bebes$age)
summary(bebes$height)
summary(bebes$smoke) 
summary(bebes$weight) 

#modelo cheio
m1 = lm(bwt~gestation+parity+age+height+smoke+weight+
gestation:parity+gestation:age+gestation:height+
gestation:smoke+gestation:weight+parity:age+parity:height+
parity:smoke+parity:weight+age:height+gestation:parity:age+
gestation:parity:height+gestation:parity:smoke+
gestation:parity:weight+gestation:age:height+gestation:age:smoke+
gestation:age:weight+gestation:height:smoke+gestation:height:weight+
gestation:smoke:weight+parity:age:height+parity:age:smoke+
parity:age:weight+age:height:smoke+age:height:weight+
height:smoke:weight, data=bebes2) 

summary(m1)
anova(m1)
#Aparentemente eu poderia tirar todas as triplas, mas o
#tutorial sugere que fazer o processo completo, j que um 
#elemento no modelo pode mudar o efetividade de outro, 
#principalmente quando compartilham alguma poro de 
#variao explicada.

#remoo de termos:

#Interao Tripla
#sem height:smoke:weight
m2 = lm(bwt~gestation+parity+age+height+smoke+weight+
          gestation:parity+gestation:age+gestation:height+
          gestation:smoke+gestation:weight+parity:age+parity:height+
          parity:smoke+parity:weight+age:height+gestation:parity:age+
          gestation:parity:height+gestation:parity:smoke+
          gestation:parity:weight+gestation:age:height+gestation:age:smoke+
          gestation:age:weight+gestation:height:smoke+gestation:height:weight+
          gestation:smoke:weight+parity:age:height+parity:age:smoke+
          parity:age:weight+age:height:smoke+age:height:weight, data=bebes2) 

anova(m1,m2)
#Modelo mais simples foi escolhido

#sem age:height:weight
m3 = lm(bwt~gestation+parity+age+height+smoke+weight+
          gestation:parity+gestation:age+gestation:height+
          gestation:smoke+gestation:weight+parity:age+parity:height+
          parity:smoke+parity:weight+age:height+gestation:parity:age+
          gestation:parity:height+gestation:parity:smoke+
          gestation:parity:weight+gestation:age:height+gestation:age:smoke+
          gestation:age:weight+gestation:height:smoke+gestation:height:weight+
          gestation:smoke:weight+parity:age:height+parity:age:smoke+
          parity:age:weight+age:height:smoke+
          height:smoke:weight, data=bebes2) 

anova(m1,m3)
#Modelo mais simples foi escolhido

#sem age:height:smoke
m4=lm(bwt~gestation+parity+age+height+smoke+weight+
        gestation:parity+gestation:age+gestation:height+
        gestation:smoke+gestation:weight+parity:age+parity:height+
        parity:smoke+parity:weight+age:height+gestation:parity:age+
        gestation:parity:height+gestation:parity:smoke+
        gestation:parity:weight+gestation:age:height+gestation:age:smoke+
        gestation:age:weight+gestation:height:smoke+gestation:height:weight+
        gestation:smoke:weight+parity:age:height+parity:age:smoke+
        parity:age:weight+age:height:weight+
        height:smoke:weight, data=bebes2) 

anova(m1,m4)
#Modelo mais simples foi escolhido

#Sem parity:age:weight
m5=lm(bwt~gestation+parity+age+height+smoke+weight+
        gestation:parity+gestation:age+gestation:height+
        gestation:smoke+gestation:weight+parity:age+parity:height+
        parity:smoke+parity:weight+age:height+gestation:parity:age+
        gestation:parity:height+gestation:parity:smoke+
        gestation:parity:weight+gestation:age:height+gestation:age:smoke+
        gestation:age:weight+gestation:height:smoke+gestation:height:weight+
        gestation:smoke:weight+parity:age:height+parity:age:smoke+
        age:height:smoke+age:height:weight+
        height:smoke:weight, data=bebes2) 

anova(m1,m5)
#Modelo mais simples foi escolhido

#Sem parity:age:smoke
m6=lm(bwt~gestation+parity+age+height+smoke+weight+
        gestation:parity+gestation:age+gestation:height+
        gestation:smoke+gestation:weight+parity:age+parity:height+
        parity:smoke+parity:weight+age:height+gestation:parity:age+
        gestation:parity:height+gestation:parity:smoke+
        gestation:parity:weight+gestation:age:height+gestation:age:smoke+
        gestation:age:weight+gestation:height:smoke+gestation:height:weight+
        gestation:smoke:weight+parity:age:height+
        parity:age:weight+age:height:smoke+age:height:weight+
        height:smoke:weight, data=bebes2) 

anova(m1,m6)
#Modelo mais simples foi escolhido

#Sem parity:age:height
m7=lm(bwt~gestation+parity+age+height+smoke+weight+
        gestation:parity+gestation:age+gestation:height+
        gestation:smoke+gestation:weight+parity:age+parity:height+
        parity:smoke+parity:weight+age:height+gestation:parity:age+
        gestation:parity:height+gestation:parity:smoke+
        gestation:parity:weight+gestation:age:height+gestation:age:smoke+
        gestation:age:weight+gestation:height:smoke+gestation:height:weight+
        gestation:smoke:weight+parity:age:smoke+
        parity:age:weight+age:height:smoke+age:height:weight+
        height:smoke:weight, data=bebes2) 

anova(m1,m7)
#Modelo mais simples foi escolhido

#Sem gestation:smoke:weight
m8=lm(bwt~gestation+parity+age+height+smoke+weight+
        gestation:parity+gestation:age+gestation:height+
        gestation:smoke+gestation:weight+parity:age+parity:height+
        parity:smoke+parity:weight+age:height+gestation:parity:age+
        gestation:parity:height+gestation:parity:smoke+
        gestation:parity:weight+gestation:age:height+gestation:age:smoke+
        gestation:age:weight+gestation:height:smoke+gestation:height:weight+
        parity:age:height+parity:age:smoke+
        parity:age:weight+age:height:smoke+age:height:weight+
        height:smoke:weight, data=bebes2) 

anova(m1,m8)
#Modelo mais simples foi escolhido

#Sem gestation:height:weight
m9=lm(bwt~gestation+parity+age+height+smoke+weight+
        gestation:parity+gestation:age+gestation:height+
        gestation:smoke+gestation:weight+parity:age+parity:height+
        parity:smoke+parity:weight+age:height+gestation:parity:age+
        gestation:parity:height+gestation:parity:smoke+
        gestation:parity:weight+gestation:age:height+gestation:age:smoke+
        gestation:age:weight+gestation:height:smoke+
        gestation:smoke:weight+parity:age:height+parity:age:smoke+
        parity:age:weight+age:height:smoke+age:height:weight+
        height:smoke:weight, data=bebes2) 

anova(m1,m9)
#Modelo mais simples foi escolhido

#Sem gestation:height:smoke
m10=lm(bwt~gestation+parity+age+height+smoke+weight+
         gestation:parity+gestation:age+gestation:height+
         gestation:smoke+gestation:weight+parity:age+parity:height+
         parity:smoke+parity:weight+age:height+gestation:parity:age+
         gestation:parity:height+gestation:parity:smoke+
         gestation:parity:weight+gestation:age:height+gestation:age:smoke+
         gestation:age:weight+gestation:height:weight+
         gestation:smoke:weight+parity:age:height+parity:age:smoke+
         parity:age:weight+age:height:smoke+age:height:weight+
         height:smoke:weight, data=bebes2) 

anova(m1,m10)
#Modelo mais simples foi escolhido

#Sem gestation:age:weight
m11=lm(bwt~gestation+parity+age+height+smoke+weight+
         gestation:parity+gestation:age+gestation:height+
         gestation:smoke+gestation:weight+parity:age+parity:height+
         parity:smoke+parity:weight+age:height+gestation:parity:age+
         gestation:parity:height+gestation:parity:smoke+
         gestation:parity:weight+gestation:age:height+gestation:age:smoke+
         gestation:height:smoke+gestation:height:weight+
         gestation:smoke:weight+parity:age:height+parity:age:smoke+
         parity:age:weight+age:height:smoke+age:height:weight+
         height:smoke:weight, data=bebes2) 

anova(m1,m11)
#Modelo mais simples foi escolhido

#Sem gestation:age:smoke
m12=lm(bwt~gestation+parity+age+height+smoke+weight+
         gestation:parity+gestation:age+gestation:height+
         gestation:smoke+gestation:weight+parity:age+parity:height+
         parity:smoke+parity:weight+age:height+gestation:parity:age+
         gestation:parity:height+gestation:parity:smoke+
         gestation:parity:weight+gestation:age:height+
         gestation:age:weight+gestation:height:smoke+gestation:height:weight+
         gestation:smoke:weight+parity:age:height+parity:age:smoke+
         parity:age:weight+age:height:smoke+age:height:weight+
         height:smoke:weight, data=bebes2) 

anova(m1,m12)
#Modelo mais simples foi escolhido

#Sem gestation:age:height
m13=lm(bwt~gestation+parity+age+height+smoke+weight+
         gestation:parity+gestation:age+gestation:height+
         gestation:smoke+gestation:weight+parity:age+parity:height+
         parity:smoke+parity:weight+age:height+gestation:parity:age+
         gestation:parity:height+gestation:parity:smoke+
         gestation:parity:weight+gestation:age:smoke+
         gestation:age:weight+gestation:height:smoke+gestation:height:weight+
         gestation:smoke:weight+parity:age:height+parity:age:smoke+
         parity:age:weight+age:height:smoke+age:height:weight+
         height:smoke:weight, data=bebes2) 

anova(m1,m13)
#Modelo mais simples foi escolhido

#Sem gestation:parity:weight
m14=lm(bwt~gestation+parity+age+height+smoke+weight+
         gestation:parity+gestation:age+gestation:height+
         gestation:smoke+gestation:weight+parity:age+parity:height+
         parity:smoke+parity:weight+age:height+gestation:parity:age+
         gestation:parity:height+gestation:parity:smoke+
         gestation:age:height+gestation:age:smoke+
         gestation:age:weight+gestation:height:smoke+gestation:height:weight+
         gestation:smoke:weight+parity:age:height+parity:age:smoke+
         parity:age:weight+age:height:smoke+age:height:weight+
         height:smoke:weight, data=bebes2) 
anova(m1,m14)
#Modelo mais simples foi escolhido

#Sem gestation:parity:smoke
m15=lm(bwt~gestation+parity+age+height+smoke+weight+
         gestation:parity+gestation:age+gestation:height+
         gestation:smoke+gestation:weight+parity:age+parity:height+
         parity:smoke+parity:weight+age:height+gestation:parity:age+
         gestation:parity:height+gestation:parity:weight+gestation:age:height+gestation:age:smoke+
         gestation:age:weight+gestation:height:smoke+gestation:height:weight+
         gestation:smoke:weight+parity:age:height+parity:age:smoke+
         parity:age:weight+age:height:smoke+age:height:weight+
         height:smoke:weight, data=bebes2) 
anova(m1,m15)
#Modelo mais simples foi escolhido

#Sem gestation:parity:height
m16=lm(bwt~gestation+parity+age+height+smoke+weight+
         gestation:parity+gestation:age+gestation:height+
         gestation:smoke+gestation:weight+parity:age+parity:height+
         parity:smoke+parity:weight+age:height+gestation:parity:age+
         gestation:parity:smoke+gestation:parity:weight+gestation:age:height+gestation:age:smoke+
         gestation:age:weight+gestation:height:smoke+gestation:height:weight+
         gestation:smoke:weight+parity:age:height+parity:age:smoke+
         parity:age:weight+age:height:smoke+age:height:weight+
         height:smoke:weight, data=bebes2) 
anova(m1,m16)
#Modelo mais simples foi escolhido

#Sem gestation:parity:age
m17=lm(bwt~gestation+parity+age+height+smoke+weight+
         gestation:parity+gestation:age+gestation:height+
         gestation:smoke+gestation:weight+parity:age+parity:height+
         parity:smoke+parity:weight+age:height+
         gestation:parity:height+gestation:parity:smoke+
         gestation:parity:weight+gestation:age:height+gestation:age:smoke+
         gestation:age:weight+gestation:height:smoke+gestation:height:weight+
         gestation:smoke:weight+parity:age:height+parity:age:smoke+
         parity:age:weight+age:height:smoke+age:height:weight+
         height:smoke:weight, data=bebes2) 

anova(m1,m17)
#Modelo mais simples foi escolhido
#todas as triplas foram retiradas
m18=lm(bwt~gestation+parity+age+height+smoke+weight+
         gestation:parity+gestation:age+gestation:height+
         gestation:smoke+gestation:weight+parity:age+parity:height+
         parity:smoke+parity:weight+age:height, data=bebes2)  

#Interao dupla
#Sem age:height
m19=lm(bwt~gestation+parity+age+height+smoke+weight+
         gestation:parity+gestation:age+gestation:height+
         gestation:smoke+gestation:weight+parity:age+parity:height+
         parity:smoke+parity:weight, data=bebes2)  
anova(m18,m19)
#Modelo mais simples foi escolhido

#Sem parity:weight
m20=lm(bwt~gestation+parity+age+height+smoke+weight+
         gestation:parity+gestation:age+gestation:height+
         gestation:smoke+gestation:weight+parity:age+parity:height+
         parity:smoke+age:height, data=bebes2)  

anova(m18,m20)
#Modelo mais simples foi escolhido

#Sem parity:smoke
m21=lm(bwt~gestation+parity+age+height+smoke+weight+
         gestation:parity+gestation:age+gestation:height+
         gestation:smoke+gestation:weight+parity:age+parity:height+
         parity:weight+age:height, data=bebes2)  
anova(m18,m21)
#Modelo mais simples foi escolhido

#Sem parity:height
m22=lm(bwt~gestation+parity+age+height+smoke+weight+
         gestation:parity+gestation:age+gestation:height+
         gestation:smoke+gestation:weight+parity:age+
         parity:smoke+parity:weight+age:height, data=bebes2)  
anova(m18,m22)
#Modelo mais simples foi escolhido

#Sem parity:age
m23=lm(bwt~gestation+parity+age+height+smoke+weight+
         gestation:parity+gestation:age+gestation:height+
         gestation:smoke+gestation:weight+parity:height+
         parity:smoke+parity:weight+age:height, data=bebes2)  
anova(m18,m23)
#Modelo mais simples foi escolhido

#Sem gestation:weight
m24=lm(bwt~gestation+parity+age+height+smoke+weight+
         gestation:parity+gestation:age+gestation:height+
         gestation:smoke+parity:age+parity:height+
         parity:smoke+parity:weight+age:height, data=bebes2)  
anova(m18,m24)
#Modelo mais simples foi escolhido

#Sem gestation:smoke
m25=lm(bwt~gestation+parity+age+height+smoke+weight+
         gestation:parity+gestation:age+gestation:height+
         gestation:weight+parity:age+parity:height+
         parity:smoke+parity:weight+age:height, data=bebes2)  
anova(m18,m25)
#Modelo 25 foi escolhido

#sem gestation:height
m26=lm(bwt~gestation+parity+age+height+smoke+weight+
     gestation:parity+gestation:age+
     gestation:smoke+gestation:weight+parity:age+parity:height+
     parity:smoke+parity:weight+age:height, data=bebes2)  
anova(m18,m26)
#Modelo mais simples foi escolhido

#sem gestation:age
m27=lm(bwt~gestation+parity+age+height+smoke+weight+
         gestation:parity+gestation:height+
         gestation:smoke+gestation:weight+parity:age+parity:height+
         parity:smoke+parity:weight+age:height, data=bebes2)  
anova(m18,m27)
#Modelo 27 foi escolhido

#sem gestation:parity
m28=lm(bwt~gestation+parity+age+height+smoke+weight+
         gestation:age+gestation:height+
         gestation:smoke+gestation:weight+parity:age+parity:height+
         parity:smoke+parity:weight+age:height, data=bebes2)  
anova(m18,m28)
#Modelo mais simples foi escolhido

#as interacoes gestation:smoke e gestation:age foram mantidas
m29=lm(bwt~gestation+parity+age+height+smoke+weight+
gestation:age+gestation:smoke, data=bebes2)  
summary(m29)
anova(m29)

#sem gestation
m30=lm(bwt~parity+age+height+smoke+weight+
gestation:age+gestation:smoke, data=bebes2)
anova(m29,m30)
#fico com m30

#sem parity
m31=lm(bwt~gestation+age+height+smoke+weight+
         gestation:age+gestation:smoke, data=bebes2)  
anova(m29,m31)
#fico com m29

#sem age
m32=lm(bwt~gestation+parity+height+smoke+weight+
     gestation:age+gestation:smoke, data=bebes2)
anova(m29,m32)
#fico com m29

#sem height
m33=lm(bwt~gestation+parity+age+smoke+weight+
         gestation:age+gestation:smoke, data=bebes2)  
anova(m29,m33)
#fico com m29

#sem smoke
m34=lm(bwt~gestation+parity+age+height+weight+
     gestation:age+gestation:smoke, data=bebes2)  
anova(m29,m34)
#fico com m29

#sem weight
m35=lm(bwt~gestation+parity+age+height+smoke+
         gestation:age+gestation:smoke, data=bebes2)  
anova(m29,m35)
#fico com m29

##para ter certeza comparei os modelos selecionados
#modelo cheio
m1
#modelo sem triplas
m18
anova(m1,m18) #fico com m18

#modelo sem duplas desnecessarias
m29
lm(bwt~gestation+parity+age+height+smoke+weight+
         gestation:age+gestation:smoke, data=bebes2)

anova(m18,m29) #fico com m29

#modelo sem variavel desnecessaria
m30
anova(m29,m30) #fico com m30

#modelo mais simples possivel
m30=lm(bwt~parity+age+height+smoke+weight+
gestation:age+gestation:smoke, data=bebes2)
anova(m30)

#pra comparar
tabela.comparar_modelos <- AICtab(m1,m2,m3,m4,m5,m6,m7,m8,m9,m10,m11,m12,m13,m14,m15,m16,m17,m18,m19,m20,m21,m22,m23,m24,m25,m26,m27,m28,m29,m30,m31,m32,m33,m34,m35, weights=T, delta=TRUE, base=TRUE)

#O modelo 30 ficou com o menor dAIC, mas o modelo 29 
#tambm poderia ser escolhido porque tambm ficou com dAIC
#menor que 2 (apesar de ser maior que do 30) e com 1 grau de 
#liberdade a mais.

par(mfrow = c(2,2), mar=c(4,4,2,2), cex.lab=1.2,
    cex.axis=1.2, las=1,  bty="n")
plot(m29)
plot(m30)

###Resposta
#Analisando os graficos e a seleao de modelos por anova e AIC, 
#levando em conta os graus de liberdade, o melhor modelo eh o 29.