####9.2 Exerccio Anlise exploratria simultnea de duas variveis

#Tarefa: Crie uma funo para sada grfica de anlises exploratrias de duas variveis. 
#Essa sada pode ter por exemplo boxplot, histograma, qq norm e y por x. A funo deve 
#permitir a entrada de dois objetos vetores de mesmo tamanho (x e y). Caso os valores de 
#x e y forem desenhados em um mesmo grfico, defina cores diferentes. As legendas devem ser 
#em portugus e a sada (return) deve apresentar o sumrio das duas variveis e o 
#coeficiente de correlao.

#DICAS:
  
#Para histogramas com variveis em um mesmo grfico pode ser utilizada a funo multhist() 
#do pacote "plotrix". Baixe, instale o pacote e veja o help da funo.
#Utilize o cdigo do eda.shape, apresentado em aula como ponto de partida.
#Lembre-se que em algumas funes grficas o argumento add=TRUE, adiciona elementos no 
#grfico anterior.
install.packages("plotrix")
library(plotrix)

eda.shape <- function(x)
{
  x11() 
  par(mfrow = c(2,2))	## muda o dispositivo grfico para 2x2
  hist(x)                 ## produz histograma de x
  boxplot(x)
  iqd <- summary(x)[5] -	summary(x)[2]     ## faz a diferena entre o quinto elemento x e o segundo
  plot(density(x,width=2*iqd),xlab="x",ylab="",type="l")
  qqnorm(x)
  qqline(x)
  par(mfrow=c(1,1))
  
}

#### Minha funcao

graph.analise <- function(x,y, 
                          na.omit = T,
                          mar=(c(4,4,2,2)), 
                          mfrow=c(2,2), 
                          xlab= "Varivel preditora", 
                          ylab= "Varivel resposta"){ 
  if(length(x)!=length(y))
  {stop("o vetores x e y possuem tamanhos diferentes")}
  
  xy <- data.frame(x,y)  
  if(na.omit)
  {               #peguei essa parte da apostila, modificado)
    dados=(na.omit(xy))
    dif=length(xy)-length(dados)
    cat("\t", dif," valores NA excludos\n")
  }
  else
  {
    dados=xy
  }
  
  x11()
  
  par(mfrow = mfrow, mar=mar)
  plot <- plot(x,y, xlab=xlab, ylab=ylab, col=c("red","blue"))
  lmxy <- lm(y ~ x)
  abline(lmxy, col = "green")
  hist(x,xlab=xlab, main= "Histograma da varivel preditora")
  hist(y,xlab=ylab, main= "Histograma da varivel resposta")
  boxplot(x,y, col=c("red","blue"), names = c("Varivel preditora", "Varivel resposta"))
 
  sumario <- summary(xy)
  coeficientes <- cor(xy)
  return(list(sumario=sumario, coeficientes=coeficientes))
}




x.teste <- rnorm(100, 10,1)
y.teste <- rnorm(100,15,1)
graph.analise(x.teste,y.teste)





