#5.1 Editando alguns parmetros grficos
saligna <-read.table("esaligna.csv", header=T, sep=",", as.is=T)
par(cex.axis=1.5, cex.lab=1.7)
plot(saligna$dap~saligna$ht,xlab= "Dimetro  altura do peito (cm)",ylab= "Altura (m)", pch=16, col="red", cex=1.4, tcl=0.3, las=1, bty="l", main="*Eucalypthus saligna*", cex.main=1.8)
#mtext("*Eucalypthus saligna*", side=3, line=0.9, at=40,cex=1.8, family="serif", las=1)

png(filename = "saligna.png")
par(cex.axis=1.5, cex.lab=1.7)
plot(saligna$dap~saligna$ht,xlab= "Dimetro  altura do peito (cm)",ylab= "Altura (m)", pch=16, col="red", cex=1.4, tcl=0.3, las=1, bty="l", main="*Eucalypthus saligna*", cex.main=1.8)
dev.off() #fechar para salvar

#5.2 Dois grficos juntos

#Use as variveis "dap" e "talhao" para construir dois grficos, colocando-os lado a lado. 
#O primeiro deve ser um grfico de desenho de caixa (boxplot) da varivel "dap" em funo do fator "talho". O segundo deve ter apenas a mdia e uma barra de desvio-padro do dap, para cada talho.
#Mantenha o mesmo padro de formatao do exerccio anterior.
#Insira tambm uma letra para dizer qual  o grfico "a" e qual  o "b" 
#(tanto faz, quem  um e quem  outro).

##Primeiro grafico
par(mfrow=c(1,2),bty="l",tcl=0.3, cex.axis=1.5, cex.lab=1.7,las=1)
class(saligna$talhao)
(as.factor(saligna$talhao))
boxplot(saligna$dap~saligna$talhao,xlab="talho", ylab="dap", main="a", cex.main=1.8)
#text(x=0.9, y=23, "a", cex=1) 
#ou
#mtext("a")

##Segundo grafico
media_dap <- tapply(saligna$dap, saligna$talhao, mean)
desvio_padrao_dap <-tapply(saligna$dap, saligna$talhao, sd)
(matriz <- as.matrix(cbind(media_dap, desvio_padrao_dap)))


#Plot
(y0 <- media_dap-desvio_padrao_dap)
(y1 <- media_dap+desvio_padrao_dap)
(limite <- range(max(y1),min(y0)))

plot(media_dap, xlab="talho", ylab="dap (mdia)", xlim=c(0,6), ylim= limite, xaxt="n", pch=19, bty="l", tcl=0.3, cex.axis=1.5, cex.lab=1.7, las=1, main="b", cex.main=1.8)
#ou
#plot(matriz[,1], ylab="dap (mdia)", xlab="talho",  ylim= limite, xaxt="n", pch=19)

#Barras
segments(1:6, y0, 1:6, y1) #x0 e x1 vo de 1 a 6 porque  o nmero de nveis do fator "talhao"
#mtext("b")

points(x=c(1:6), y0, pch="_")		
points(x=c(1:6), y1+0.05, pch="_")#acrescentei 0.05 para arrumar a barra de erro

axis(1, at=1:6, labels=c("16", "17", "18", "22", "23", "32"))

dev.off() #fechar para salvar

#5.3 Adivinhando o cdigo
dados <-read.table("exercicio3.csv", header=T, sep=",", as.is=T)
summary(dados)
str(dados)
range(dados$x1)
range(dados$y1)

#Primeiro grafico
par(mfrow=c(1,2), family="serif")

plot(dados$x1,dados$y1, tcl=0.3, xlab="Log(Patch size)(ha)", ylab="", bty="L", pch=17, xlim=c(0.5,2.2), ylim=c(0,3), cex=1.3, cex.lab=1.3, cex.axis=1.2) #pch=17 faz os triangulos 

mtext("Euclidean distances", side=2, cex=1.7, line=2.3)	#fonte do eixo x  
text(2.2,3,"a", cex=2)
segments(x0=0.5, y0=2.25 , x1=2.16, y1=1, lwd=2) #lwd eh a espessura da linha

#Segundo grafico
par(tcl=0.3, bty="L")			
boxplot(dados$x2~dados$y2, xlab="", ylab="", ylim=c(0,3), cex.axis=1.2, xaxt="n", outline=FALSE) 	#outline=FALSE pra excluir os outliers
axis(1, at=1:6, labels=c("Small\n","Medium\nEdge","Medium\nInterior","Large\nEdge","Large\nInterior","Control\n"))

text(x=1:5,y=3,labels=c("*","*","**","*","***"),cex=1.6)
text(6.5,3,"b", cex=2) 
 
dev.off() #fechar para salvar
