#Uma estimativa da incerteza na previso do modelo
bebes<-read.table("babies.txt", sep="", dec=".", header=T, as.is=T)
head(bebes)
str(bebes)
tail(bebes)


bebes2<- bebes[bebes$gestation<999 & bebes$parity<9 & bebes$age<99 & bebes$height<99
               & bebes$weight<999 & bebes$smoke<9,] 
mod<-lm(bwt~gestation,data = bebes2)

valoresx<-seq(min(bebes2$gestation) -10, max(bebes2$gestation) + 10, length.out=100)
preditos<-predict(mod, newdata = data.frame(gestation=valoresx), interval="confidence")

varianciay<-var(bebes2$bwt)
obs<-1/length(bebes2$gestation)
resto<-preditos-mean(bebes2$gestation)^2/sum(sd(bebes2$gestation)^2)

erro<-sqrt(varianciay*(obs/resto)) ## nesse ponto esta havendo produo de NaN no consegui solucionar a partir daqui
valort<-qt(0.025, length(bebes2$gestation)-2, lower.tail = F)
cofiana<-valort*erro



#Galileu Estava Certo ? 
init.h = c(600, 700, 800, 950, 1100, 1300, 1500)
h.d = c(253, 337, 395, 451, 495, 534, 573)

mod1<-lm(init.h~h.d)
mod2 <- update(mod1,.~. +I(init.h^2))
mod3<-update(mod2,.~. +I(init.h^3))

anova(mod2,mod3)

#Como a anova entre os modelos deu significativa P=0,0004097 isso mostra que o polinomio de terceiro grau  realmente 
#um modelo melhor para descrever os dados de Galileu.


#Massa de Recm-Nascidos
bebes<-read.table("babies.txt", sep="", dec=".", header=T, as.is=T)
head(bebes)
str(bebes)
tail(bebes)

bebes2<- bebes[bebes$gestation<999 & bebes$parity<9 & bebes$age<99 & bebes$height<99
       & bebes$weight<999 & bebes$smoke<9,] 

head(bebes2)
#fullmodel
modcheio<-lm(bwt~gestation+parity+age+height+weight+smoke+gestation:parity+gestation:age+gestation:height+
  gestation:weight+gestation:smoke+parity:age+parity:height+parity:weight+ 
  parity:smoke+age:height+age:weight+age:smoke+height:weight+height:smoke+
  weight:smoke+gestation:parity:age+gestation:height:weight+gestation:age:smoke+
  height:weight:smoke+gestation:parity:smoke +parity:age:smoke, data=bebes2)
anova(modcheio)

  #retirando interaes triplas
mod1<-lm(bwt~gestation+parity+age+height+weight+smoke+gestation:parity+gestation:age+gestation:height+
           gestation:weight+gestation:smoke+parity:age+parity:height+parity:weight+ 
           parity:smoke+age:height+age:weight+age:smoke+height:weight+height:smoke+
           weight:smoke, data=bebes2)
anova(modcheio,mod1)

#no significativo mantemos o modelo mais simples
#simplificando mais (sem weight:smoke)

mod2<-lm(bwt~gestation+parity+age+height+weight+smoke+gestation:parity+gestation:age+gestation:height+
           gestation:weight+gestation:smoke+parity:age+parity:height+parity:weight+ 
           parity:smoke+age:height+age:weight+age:smoke+height:weight+height:smoke, data=bebes2)
anova(mod1,mod2)

#sem height:smoke
mod3<-lm(bwt~gestation+parity+age+height+weight+smoke+gestation:parity+gestation:age+gestation:height+
           gestation:weight+gestation:smoke+parity:age+parity:height+parity:weight+ 
           parity:smoke+age:height+age:weight+age:smoke+height:weight, data=bebes2)

anova(mod3,mod2)

#simplificando mais (sem height:weight)
mod4<-lm(bwt~gestation+parity+age+height+weight+smoke+gestation:parity+gestation:age+gestation:height+
           gestation:weight+gestation:smoke+parity:age+parity:height+parity:weight+ 
           parity:smoke+age:height+age:weight+age:smoke, data=bebes2)
anova(mod4,mod3)

#sem age:smoke
mod5<-lm(bwt~gestation+parity+age+height+weight+smoke+gestation:parity+gestation:age+gestation:height+
           gestation:weight+gestation:smoke+parity:age+parity:height+parity:weight+ 
           parity:smoke+age:height+age:weight, data=bebes2)
anova(mod4,mod5)

#sem age:weight
mod5<-lm(bwt~gestation+parity+age+height+weight+smoke+gestation:parity+gestation:age+gestation:height+
           gestation:weight+gestation:smoke+parity:age+parity:height+parity:weight+ 
           parity:smoke+age:height, data=bebes2)
anova(mod5,mod4)

#sem age:height

mod6<-lm(bwt~gestation+parity+age+height+weight+smoke+gestation:parity+gestation:age+gestation:height+
           gestation:weight+gestation:smoke+parity:age+parity:height+parity:weight+ 
           parity:smoke, data=bebes2)
anova(mod6,mod5)

#sem parity:smoke
mod7<-lm(bwt~gestation+parity+age+height+weight+smoke+gestation:parity+gestation:age+gestation:height+
           gestation:weight+gestation:smoke+parity:age+parity:height+parity:weight, data=bebes2)
anova(mod6,mod7)

#sem parity:weight
mod8<-lm(bwt~gestation+parity+age+height+weight+smoke+gestation:parity+gestation:age+gestation:height+
           gestation:weight+gestation:smoke+parity:age+parity:height, data=bebes2)
anova(mod8,mod7)

#sem parity:height
mod9<-lm(bwt~gestation+parity+age+height+weight+smoke+gestation:parity+gestation:age+gestation:height+
           gestation:weight+gestation:smoke+parity:age, data=bebes2)
anova(mod8,mod9)

#sem parity:age
mod10<-lm(bwt~gestation+parity+age+height+weight+smoke+gestation:parity+gestation:age+gestation:height+
           gestation:weight+gestation:smoke, data=bebes2)
anova(mod9,mod10)

#sem gestation:smoke
mod11<-lm(bwt~gestation+parity+age+height+weight+smoke+gestation:parity+gestation:age+gestation:height+
            gestation:weight, data=bebes2)
anova(mod10,mod11)
#aqui temos uma diferena significativa portanto mantemos o mod10

#tentando tirar gestation:weight e manter gestation:smoke
mod12<-lm(bwt~gestation+parity+age+height+weight+smoke+gestation:parity+gestation:age+gestation:height+
            gestation:smoke, data=bebes2)
anova(mod10,mod12)

#mantemos mod12 e tentando tirar agora gestation:height

mod13<-lm(bwt~gestation+parity+age+height+weight+smoke+gestation:parity+gestation:age+
                   gestation:smoke, data=bebes2)
anova(mod13,mod12)

#mantemos mod13
mod14<-lm(bwt~gestation+parity+age+height+weight+smoke+gestation:parity+
                   gestation:smoke, data=bebes2)
anova(mod14,mod13)

mod15<-lm(bwt~gestation+parity+age+height+weight+gestation:parity+
            gestation:smoke, data=bebes2)
anova(mod15,mod13)

#mantemos mod13 aparentemente o melhor modelo
