library(MASS)

data("Animals")

anim.m2 <- lm(log(brain)~log(body),data=Animals, 
              subset=!(log(Animals$body)>8&log(Animals$brain)<6))


anim.m0 <- lm(log(brain)~1, data=Animals, 
              subset=!(log(Animals$body)>8&log(Animals$brain)<6))

anova(anim.m0,anim.m2)


#1)Qual a relacao do comando 'anova' acima com anova(anim.m2)

#Ambos realizam a mesma analise. Em anova(anim.m0, anim.m2) o modelo nulo (anim.m0)
#esta sendo incluido como argumento, e no comomando anova(anim.m2) ele também esta incluido no comando
#pois como default a funcao anova sempre compara o seu modelo com o modelo nulo (ex.: anim.0)

#2) Qual a relacao entre os valores obtidos por estes comandos

summary(anim.m0)
mean(log(Animals$brain[!(log(Animals$body)>8&log(Animals$brain)<6)]))
sd(log(Animals$brain[!(log(Animals$body)>8&log(Animals$brain)<6)]))

#A media do modelo anim.m2 me retorna o ponto onde o eixo y sera cortado no modelo nulo (anim.m0)
#que vem a ser a grande media. E o sd do modelo anim.m2 representa o desvio padrão dos residuos
#do modelo nulo (anim.m0) que estao ligados ao valor da grande media.











