###Uma estimativa da incerteza na previsao do modelo####

bebes<-read.table("babies.txt", header=T, sep=" ", as.is=T)
bebes[bebes$gestation==999,]<-NA #atribuindo NA aos valores ignorados na coluna gestacao
bebes1<-na.exclude(bebes) #exlcuindo os NA's e criando um novo dataframe bebes1
bebes1$bwt<-(bebes1$bwt)*0.028 #fazendo a conversao de oncas para kg na massa ao nascer

head(bebes1)
str(bebes1)

lmbebes<- lm(bwt~gestation, data = bebes1) #regressao linear de bwt em funcao de gestation
bebes1$predw <- predict(lmbebes) 
bebes1$resw <- residuals(lmbebes)

#definindo parametros globais
par(mar = c(4,4,2,2), cex.lab = 1.5, cex.axis = 1.2, las = 1, bg = "gray90", bty = "n")
#definindo valores dos eixos 
plot(NA, type = "n", axes = F, ann = F, xlim = range(bebes1$bwt), ylim = range(bebes1$gestation) )
#plot de bwt em funcao de gestation
plot(bwt ~ gestation , data=bebes1, pch = 19,cex= 1.5, col = rgb(0,0,1, 0.4))

#predito pelo modelo

newx <- seq(min(bebes1$gestation) -10, max(bebes1$gestation) + 10, length.out=100)
preds <- predict(lmbebes, newdata = data.frame(gestation = newx), 
                 interval = 'confidence')

table(rbind(head(preds),tail(preds)))

#grafico modelo linear

polygon(c(rev(newx), newx), c(rev(preds[ ,3]), preds[ ,2]),
        col = rgb(0,0,0,0.2), border = NA)
abline(modelosimples, lwd = 2.5, col = "black")

###Galileu estava certo?####

init.h<- c(600, 700, 800, 950, 1100, 1300, 1500)
h.d<- c(253, 337, 395, 451, 495, 534, 573)

plot(h.d~init.h)

mod1<-lm(h.d~init.h)
abline(mod1)

mod2 <- update(mod1,.~. +I(init.h^2))
anova(mod1,mod2)

mod3<-update(mod2,.~. +I(init.h^3))

anova(mod2,mod3)
summary(mod3)

cf.m2<-coef(mod2)
cf.m3<-coef(mod3)
curve(cf.m2[1]+cf.m2[2]*x+cf.m2[3]*x^2, add=T, lty=2, col="green")
curve(cf.m3[1]+cf.m3[2]*x+cf.m3[3]*x^2 +cf.m3[4]*x^3, add=T, lty=2, col="red")

#Resposta: O modelo com o polinomio de terceiro grau (mod3) descreve melhor os dados do experimento de Galileu.

###Massa de recm-nascidos####

bebes<-read.table("babies.txt", header=T, sep=" ", as.is=T)

bebes[bebes$bwt==999|bebes$gestation==999|bebes$parity==9|bebes$age==99|bebes$height==99|bebes$weight==999|bebes$smoke==9,]<-NA

bebes1<-na.exclude(bebes)

mlfull<-lm(bwt~ gestation + parity+ age+ height+ weight + smoke+
             gestation:parity+ gestation:age + gestation:height + gestation:weight +
             gestation:smoke + gestation:parity:age+ gestation:age:height+ 
             gestation:height:weight+ gestation:weight:smoke, data=bebes1)

ml01<-lm(bwt~ gestation + parity+ age+ height+ weight + smoke+
           gestation:parity+ gestation:age + gestation:height + gestation:weight +
           gestation:smoke + gestation:parity:age+ gestation:age:height+ 
           gestation:height:weight, data=bebes1)
anova(ml01, mlfull)

ml02<-lm(bwt~ gestation + parity+ age+ height+ weight + smoke+
           gestation:parity+ gestation:age + gestation:height + gestation:weight +
           gestation:smoke + gestation:parity:age+ gestation:age:height, data=bebes1)
anova(ml01, ml02)

ml03<-lm(bwt~ gestation + parity+ age+ height+ weight + smoke+
           gestation:parity+ gestation:age + gestation:height + gestation:weight +
           gestation:smoke + gestation:parity:age, data=bebes1)
anova(ml02, ml03)

ml04<-lm(bwt~ gestation + parity+ age+ height+ weight + smoke+
           gestation:parity+ gestation:age + gestation:height + gestation:weight +
           gestation:smoke, data=bebes1)
anova(ml03, ml04)

ml05<-lm(bwt~ gestation + parity+ age+ height+ weight + smoke+
           gestation:parity+ gestation:age + gestation:height + gestation:weight, data=bebes1)
anova(ml04, ml05)

ml06<-lm(bwt~ gestation + parity+ age+ height+ weight + smoke+
           gestation:parity+ gestation:age + gestation:height +
           gestation:smoke, data=bebes1)
anova(ml04, ml06)

ml07<-lm(bwt~ gestation + parity+ age+ height+ weight + smoke+
           gestation:parity+ gestation:age + gestation:smoke, data=bebes1)
anova(ml06, ml07)

ml08<-lm(bwt~ gestation + parity+ age+ height+ weight + smoke+
           gestation:parity+ gestation:smoke, data=bebes1)
anova(ml07, ml08)

ml09<-lm(bwt~ gestation + parity+ age+ height+ weight + smoke+ gestation:smoke, data=bebes1)
anova(ml07, ml09)

ml10<-lm(bwt~ parity+ age+ height+ weight+ smoke+
           gestation:parity+ gestation:age + gestation:smoke, data=bebes1)
anova(ml07, ml10)

ml11<-lm(bwt~ age+ height+ weight+ smoke+
           gestation:parity+ gestation:age + gestation:smoke, data=bebes1)
anova(ml10, ml11)

ml12<-lm(bwt~ height+ weight+ smoke+
           gestation:parity+ gestation:age + gestation:smoke, data=bebes1)
anova(ml11, ml12)

#Resposta: modelo minimo adequado ml11<- lm(bwt~ age+ height+ weight+ smoke+ gestation:parity+ gestation:age + gestation:smoke, data=bebes1)
