#####################################
##Exerccios Anlises Exploratrias##
########### Monalisa ################

#4.1.Rios
#Exerccio feito no notaR

#4.2.Cervejas
cervejas <-c("chope","lata","garrafa","chope","garrafa", "garrafa","lata","lata","nenhuma","lata","garrafa","garrafa", "garrafa","lata","lata","lata","garrafa","lata","chope","nenhuma", "garrafa","garrafa","garrafa","chope","garrafa","garrafa","chope","garrafa","lata","lata")


#Conferindo os dados
cervejas
class(cervejas)
head(cervejas)
str(cervejas)
summary(cervejas)

#1.Represente este resultado como um grfico de barras e um dotplot (funo dotchart).
#Grfico de barras
barplot(sort(table(cervejas),ylab="N de estudantes",xlab="Tipo de cerveja preferida"))
dotchart(sort(table(cervejas)))

#2.Qual tem maior razo dado/tinta?
#O primeiro grfico do tipo barplot

#4.3 Caixetais
#Carregando e conferindo os dados
setwd("C:\\Users\\windows\\Documents\\MEGA\\Doutorado\\Disciplinas\\R\\03_analise_exploratoria")
cax = read.csv("caixeta.csv", header=TRUE, as.is=TRUE)
summary(cax)
head(cax)
str(cax)

#1.Construa um histograma do dap dos fustes dos caixetais
#CAP = pi*DAP
#DAP = CAP/pi
cax$dap=cax$cap/(pi)
par(mfrow=c(1,1),las=1)
hist(cax$dap,xlab="DAP(cm)",ylab="Frequncia")

#2.Construa histogramas da altura das rvores para os diferentes caixetais
unique(cax$local) #verificando nome dos locais
par(mfrow=c(2,2),las=1)
hist(cax$h[cax$local=="chauas"],xlab="Altura",ylab="Frequncia",main="Chauas",col="gray")
hist(cax$h[cax$local=="jureia"],xlab="Altura",ylab="Frequncia",main="Juria",col="gray")
hist(cax$h[cax$local=="retiro"],xlab="Altura",ylab="Frequncia",main="Retiro",col="gray")

#3.H diferenas entre as estruturas (distribuio de tamanhos) dos caixetais?
tapply(cax$h,cax$local,mean)
tapply(cax$h,cax$local,median)

#H pequenas diferenas na estrutura de tamanho dos locais quando analisamos as medidas de tendncia central. Porm,as medidas de tendncia central podem no ser informativas por si s. Olhando a distribuio dos dados atravs dos histogramas podemos obter informaes complementares sobre a estrutura da vegetao. Em Chauas h uma maior concentrao de observaes de rvores em torno da mdia e poucas observaes nas maiores classes de altura. Em Jureia, a distribuio das alturas se assemelha a uma distribuio normal, com a maior frequncia de ocorrncias em torno da mdia, enquanto a frequncia de observaes diminui de forma aproximadamente simtrica em direo aos maiores e menores valores de altura. J em Retiro parece haver duas classes de alturas mais comuns (distribuio de observaes com dois picos: bimodal).

#4.4 Eucaliptos
#1.Utilize o grfico boxplot para analisar o DAP de rvores de E. grandis em funo das variveis regio (regiao) e rotao (rotacao)

#Carregando o arquivo e conferindo os dados
e.grandis = read.csv("egrandis.csv", header=TRUE, sep=";",as.is=TRUE)
summary(e.grandis)
str(e.grandis)
head(e.grandis)

#DAP~regio
unique(sort(e.grandis$regiao)) #conferindo o nome das regies por ordem alfabtica
boxname = paste(sort(unique(e.grandis$regiao))) #criando o nome dos boxplots

#Criando o grfico
par(mfrow=c(1,1),las=1)
boxplot(e.grandis$dap[e.grandis$regiao=="Bofete"],e.grandis$dap[e.grandis$regiao=="Botucatu"],e.grandis$dap[e.grandis$regiao=="Itatinga"],e.grandis$dap[e.grandis$regiao=="Salto"],ylab="DAP(cm)",ylim=c(0,40),col="salmon",names=boxname)


#DAP~rotao
unique(e.grandis$rotacao)
boxname.r=c("Rotao1","Rotao2")

par(mfrow=c(1,1),las=1)
boxplot(e.grandis$dap[e.grandis$rotacao==1],e.grandis$dap[e.grandis$rotacao==2],col="salmon",names=boxname.r,ylim=c(0,40),ylab="DAP(cm)")

#2.Avalie a normalidade da altura do conjunto total de rvores com um grfico quantil-quantil contra a distribuio normal
qqnorm(e.grandis$h)
qqline(e.grandis$h)
#os dados no aparentam ter distribuio normal, pois vrias observaes caem distantes da linha de quantis esperados para uma distribuio terica.


#4.5 Mais Caixetais
cax = read.csv("caixeta.csv", header=TRUE, as.is=TRUE)

#1.Analise a relao dap-altura ('dap' e 'h') em funo do caixetal (local) com a funo plot, mas somente para as rvores de caixeta (Tabebuia cassinoides)
#Inspecionando os dados
str(cax)
head(cax)

#criando uma matriz com os dados da espcie de interesse
tc=subset(cax,cax$especie=="Tabebuia cassinoides",c(cap,fuste,arvore,local,h))

#calculando a rea basal para cada fuste
#area basal=(pi*(dap^2))/4
#mas ainda no temos dap, que pode ser obtido por: CAP/pi
tc$dap=tc$cap/pi
tc$ab.fuste=(pi*(tc$dap^2))/4 #rea basal por fuste

#Calculando rea basal por rvore em cada local: soma da rea basal dos fustes
unique(tc$local) #nome dos locais
ab.arv.chauas=tapply(tc$ab.fuste[tc$local=="chauas"],tc$arvore[tc$local=="chauas"],sum)
ab.arv.jureia=tapply(tc$ab.fuste[tc$local=="jureia"],tc$arvore[tc$local=="jureia"],sum)
ab.arv.retiro=tapply(tc$ab.fuste[tc$local=="retiro"],tc$arvore[tc$local=="retiro"],sum)


#Diametro mdio de cada rvore deduzido a partir da rea basal total por rvore (soma dos fustes)
#area basal = (pi*dap^2)/4 ou dap=sqrt((4*area basal)/pi)
dap.arv.chauas=sqrt((4*ab.arv.chauas)/pi)
dap.arv.jureia=sqrt((4*ab.arv.jureia)/pi)
dap.arv.retiro=sqrt((4*ab.arv.retiro)/pi)

#Extraindo a altura das rvores
#como as linhas so fustes, a altura de cada rvore ser dada pela mdia da altura de todos os seus fustes
h.chauas=tapply(tc$h[tc$local=="chauas"],tc$arvore[tc$local=="chauas"],mean)
h.jureia=tapply(tc$h[tc$local=="jureia"],tc$arvore[tc$local=="jureia"],mean)
h.retiro=tapply(tc$h[tc$local=="retiro"],tc$arvore[tc$local=="retiro"],mean)

#Agregando as informaes
chauas=cbind(h.chauas,dap.arv.chauas)
jureia=cbind(h.jureia,dap.arv.jureia)
retiro=cbind(h.retiro,dap.arv.retiro)

head(chauas)
head(jureia)
head(retiro)

#Investigando a relao DAP-h das rvores em funo do caixetal (local)
par(mfrow=c(1,1),las=1)
plot(chauas)
plot(jureia)
plot(retiro)
#Aparentemente h uma relao positiva linear entre DAP e altura das rvores, com rvores mais altas tendendo a maiores dimetros em relao a rvores mais baixas

#2.Para a mesma relao do item anterior, verifique linearidade com a funo scatter.smooth
?scatter.smooth
scatter.smooth(chauas)
scatter.smooth(jureia)
scatter.smooth(retiro)
#Um modelo linear parece se ajustar bem a relao entre DAP e altura das rvores do estudo, embora na rea 1(Chauas) haja um ponto extremo alavancando a linha de tendncia

#3.Utilizando o pacote lattice, analise a relao dap-altura ('dap' e 'h') em funo do caixetal (local), mas somente para as rvore) de caixeta (Tabebuia cassinoides).
library(lattice)
xyplot(dap.arv.chauas~h.chauas) 
xyplot(dap.arv.jureia~h.jureia)
xyplot(dap.arv.retiro~h.retiro)
