#1.Uma estimativa da incerteza na previso do modelo
#carregando os dados
setwd("C:\\Users\\windows\\Documents\\MEGA\\Doutorado\\Disciplinas\\R\\06_modelos_lineares")
babies = read.table("babies.txt", header=T, sep="")
head(babies)
str(babies)
class(babies)
dim(babies)

#retirando os valores ignorados
dados.ignorados = babies[babies$bwt==999|
                                 babies$gestation==999|
                                 babies$parity==9|
                                 babies$age==99|
                                 babies$height==99|
                                 babies$weight==999|
                                 babies$smoke==9,]
dados.ignorados

#Criando um vetor com o endereo das linhas que contm valores ignorados
linhas = row.names.data.frame(dados.ignorados)
linhas = as.numeric(linhas)

#Excluindo as linhas com valores igorados
babies = data.frame(babies[-linhas,])

#Conferindo
babies[babies$bwt==999|babies$gestation ==999|babies$parity==9|babies$age==99|babies$height==99|babies$weight==999|babies$smoke==9,]

#Transformando a unidade de peso de ona para kg
babies$bwt = babies$bw/35.274

#Criando um novo eixo de x com 100 valores entre o mximo e o mnimo
range(babies$gestation)
novo.x = seq(from=min(babies$gestation),to = max(babies$gestation),len=100)

#Calculando o intervalo de confiana
ssx = sum((novo.x-mean(babies$gestation))^2)
s2 = var(babies$bwt)
n = length(babies$bwt)
x = novo.x
x.m = mean(x)

se.positivo = sqrt(s2*((1/n)+((x-x.m)^2/ssx)))
se.negativo = -(se.positivo)

#Construindo o grfico
par(mfrow=c(1,1), 
    mar=c(4,4,2,2),
    cex.lab=1.5,
    cex.axis=1.2, las=1,
    bg = "gray70", bty="n")

plot(NA, type="n", axes = FALSE, ann = FALSE,
     xlim =range(babies$gestation), ylim = range(babies$bwt)) 
rect(par()$usr[1],par()$usr[3], par()$usr[2],par()$usr[4],
     col="gray90")
points(babies$bwt ~ babies$gestation, data = babies, pch = 19,cex= 1.0,
       col = rgb(0,0,1, 0.4))
axis(1)
axis(2)
mtext("Tempo de gestao (dias)", 1,  line=2.5, cex = 1.2)
mtext("Peso do beb (kg)", 2, line=2.5, cex = 1.2, las = 0)

#Plotando o modelo
mod = lm(babies$bwt~babies$gestation,data=babies)
abline(mod)

##No consegui plotar o intervalo de confiana, mesmo aps vrias tentativas



#########################################################################

#2.Galileu estava certo?
#Carregando os dados
init.h = c(600, 700, 800, 950, 1100, 1300, 1500)
h.d = c(253, 337, 395, 451, 495, 534, 573)
plot(h.d~init.h)

#Modelos concorrentes
#1.reta (y=a+bx)
mod1=lm(h.d~init.h)

#2.parbola (y=a+bx+cx^2)
mod2=update(mod1,.~. +I(init.h^2))

#3.polinmio de 3grau: (y=a+bx+cx^2+dx^3)
mod3=update(mod1,.~. +I(init.h^2)+I(init.h^3))

#Comparao de modelos
anova(mod1,mod2)
anova(mod2,mod3)

#Plotando a reta e as curvas no grfico:
#Mod1
cf1 = coef(mod1)
abline(mod1, col="red")

#Mod2
cf2 = coef(mod2)
curve(cf2[1]+cf2[2]*x+cf2[3]*x^2, add=T, lty=2, col="blue")

#Mod3
cf3 = coef(mod3)
curve(cf3[1]+cf3[2]*x+cf3[3]*x^2+cf3[4]*x^3, add=T, lty=2,col="green")

#Analisando o orfico e o resultado da anova chegamos a concluso de que o modelo 3 (polinmio de 3 grau) parece o mais adequado para descrever os dados de Galileu, deixando a menor quantidade de variao no explicada.

############################################################################

#3.Peso dos bebs
#Eliminao dos valores ignorados foi feita no exerccio 1
#Seleo de modelos: partindo do modelo cheio at o modelo mnimo adequado
#S sero consideradas as interaes de at terceira ordem que ainda so passveis de interpretao biolgica

m1 = lm(babies$bwt ~ babies$gestation + babies$parity + babies$age + babies$height + babies$weight + babies$smoke + 
          babies$gestation:babies$parity + 
          babies$gestation:babies$age + 
          babies$gestation:babies$height + 
          babies$gestation:babies$weight + 
          babies$gestation:babies$smoke +
          babies$parity:babies$age + 
          babies$parity:babies$height + 
          babies$parity:babies$weight + 
          babies$parity:babies$smoke + 
          babies$age:babies$height + 
          babies$age:babies$weight + 
          babies$age:babies$smoke + 
          babies$height:babies$weight + 
          babies$height:babies$smoke + 
          babies$weight:babies$smoke + 
          babies$gestation:babies$parity:babies$age +
          babies$gestation:babies$parity:babies$height +
          babies$gestation:babies$parity:babies$weight + 
          babies$gestation:babies$parity:babies$smoke + 
          babies$gestation:babies$age:babies$height +
          babies$gestation:babies$age:babies$weight +
          babies$gestation:babies$age:babies$smoke +
          babies$gestation:babies$height:babies$weight +
          babies$gestation:babies$height:babies$smoke +
          babies$gestation:babies$weight:babies$smoke +
          babies$parity:babies$age:babies$height +
          babies$parity:babies$age:babies$weight +
          babies$parity:babies$age:babies$smoke +
          babies$age:babies$height:babies$weight +
          babies$age:babies$height:babies$smoke +
          babies$height:babies$weight:babies$smoke, 
        data=babies)

m2 = lm(babies$bwt ~ babies$gestation + babies$parity + babies$age + babies$height + babies$weight + babies$smoke + 
          babies$gestation:babies$parity + 
          babies$gestation:babies$age + 
          babies$gestation:babies$height + 
          babies$gestation:babies$weight + 
          babies$gestation:babies$smoke +
          babies$parity:babies$age + 
          babies$parity:babies$height + 
          babies$parity:babies$weight + 
          babies$parity:babies$smoke + 
          babies$age:babies$height + 
          babies$age:babies$weight + 
          babies$age:babies$smoke + 
          babies$height:babies$weight + 
          babies$height:babies$smoke + 
          babies$weight:babies$smoke + 
          babies$gestation:babies$parity:babies$age +
          babies$gestation:babies$parity:babies$height +
          babies$gestation:babies$parity:babies$weight + 
          babies$gestation:babies$parity:babies$smoke + 
          babies$gestation:babies$age:babies$height +
          babies$gestation:babies$age:babies$weight +
          babies$gestation:babies$age:babies$smoke +
          babies$gestation:babies$height:babies$weight +
          babies$gestation:babies$height:babies$smoke +
          babies$gestation:babies$weight:babies$smoke +
          babies$parity:babies$age:babies$height +
          babies$parity:babies$age:babies$weight +
          babies$parity:babies$age:babies$smoke +
          babies$age:babies$height:babies$weight +
          babies$age:babies$height:babies$smoke,
        data=babies)
anova(m1,m2)

m3 = lm(babies$bwt ~ babies$gestation + babies$parity + babies$age + babies$height + babies$weight + babies$smoke + 
          babies$gestation:babies$parity + 
          babies$gestation:babies$age + 
          babies$gestation:babies$height + 
          babies$gestation:babies$weight + 
          babies$gestation:babies$smoke +
          babies$parity:babies$age + 
          babies$parity:babies$height + 
          babies$parity:babies$weight + 
          babies$parity:babies$smoke + 
          babies$age:babies$height + 
          babies$age:babies$weight + 
          babies$age:babies$smoke + 
          babies$height:babies$weight + 
          babies$height:babies$smoke + 
          babies$weight:babies$smoke + 
          babies$gestation:babies$parity:babies$age +
          babies$gestation:babies$parity:babies$height +
          babies$gestation:babies$parity:babies$weight + 
          babies$gestation:babies$parity:babies$smoke + 
          babies$gestation:babies$age:babies$height +
          babies$gestation:babies$age:babies$weight +
          babies$gestation:babies$age:babies$smoke +
          babies$gestation:babies$height:babies$weight +
          babies$gestation:babies$height:babies$smoke +
          babies$gestation:babies$weight:babies$smoke +
          babies$parity:babies$age:babies$height +
          babies$parity:babies$age:babies$weight +
          babies$parity:babies$age:babies$smoke +
          babies$age:babies$height:babies$weight,
          data=babies)
anova(m2,m3)

m4 = lm(babies$bwt ~ babies$gestation + babies$parity + babies$age + babies$height + babies$weight + babies$smoke + 
          babies$gestation:babies$parity + 
          babies$gestation:babies$age + 
          babies$gestation:babies$height + 
          babies$gestation:babies$weight + 
          babies$gestation:babies$smoke +
          babies$parity:babies$age + 
          babies$parity:babies$height + 
          babies$parity:babies$weight + 
          babies$parity:babies$smoke + 
          babies$age:babies$height + 
          babies$age:babies$weight + 
          babies$age:babies$smoke + 
          babies$height:babies$weight + 
          babies$height:babies$smoke + 
          babies$weight:babies$smoke + 
          babies$gestation:babies$parity:babies$age +
          babies$gestation:babies$parity:babies$height +
          babies$gestation:babies$parity:babies$weight + 
          babies$gestation:babies$parity:babies$smoke + 
          babies$gestation:babies$age:babies$height +
          babies$gestation:babies$age:babies$weight +
          babies$gestation:babies$age:babies$smoke +
          babies$gestation:babies$height:babies$weight +
          babies$gestation:babies$height:babies$smoke +
          babies$gestation:babies$weight:babies$smoke +
          babies$parity:babies$age:babies$height +
          babies$parity:babies$age:babies$weight +
          babies$parity:babies$age:babies$smoke,
        data=babies)

anova(m3,m4)

m5 = lm(babies$bwt ~ babies$gestation + babies$parity + babies$age + babies$height + babies$weight + babies$smoke + 
          babies$gestation:babies$parity + 
          babies$gestation:babies$age + 
          babies$gestation:babies$height + 
          babies$gestation:babies$weight + 
          babies$gestation:babies$smoke +
          babies$parity:babies$age + 
          babies$parity:babies$height + 
          babies$parity:babies$weight + 
          babies$parity:babies$smoke + 
          babies$age:babies$height + 
          babies$age:babies$weight + 
          babies$age:babies$smoke + 
          babies$height:babies$weight + 
          babies$height:babies$smoke + 
          babies$weight:babies$smoke + 
          babies$gestation:babies$parity:babies$age +
          babies$gestation:babies$parity:babies$height +
          babies$gestation:babies$parity:babies$weight + 
          babies$gestation:babies$parity:babies$smoke + 
          babies$gestation:babies$age:babies$height +
          babies$gestation:babies$age:babies$weight +
          babies$gestation:babies$age:babies$smoke +
          babies$gestation:babies$height:babies$weight +
          babies$gestation:babies$height:babies$smoke +
          babies$gestation:babies$weight:babies$smoke +
          babies$parity:babies$age:babies$height +
          babies$parity:babies$age:babies$weight,
                  data=babies)
anova(m4,m5)

m6 = lm(babies$bwt ~ babies$gestation + babies$parity + babies$age + babies$height + babies$weight + babies$smoke + 
          babies$gestation:babies$parity + 
          babies$gestation:babies$age + 
          babies$gestation:babies$height + 
          babies$gestation:babies$weight + 
          babies$gestation:babies$smoke +
          babies$parity:babies$age + 
          babies$parity:babies$height + 
          babies$parity:babies$weight + 
          babies$parity:babies$smoke + 
          babies$age:babies$height + 
          babies$age:babies$weight + 
          babies$age:babies$smoke + 
          babies$height:babies$weight + 
          babies$height:babies$smoke + 
          babies$weight:babies$smoke + 
          babies$gestation:babies$parity:babies$age +
          babies$gestation:babies$parity:babies$height +
          babies$gestation:babies$parity:babies$weight + 
          babies$gestation:babies$parity:babies$smoke + 
          babies$gestation:babies$age:babies$height +
          babies$gestation:babies$age:babies$weight +
          babies$gestation:babies$age:babies$smoke +
          babies$gestation:babies$height:babies$weight +
          babies$gestation:babies$height:babies$smoke +
          babies$gestation:babies$weight:babies$smoke +
          babies$parity:babies$age:babies$height,
          data=babies)
anova(m5,m6)

m7 = lm(babies$bwt ~ babies$gestation + babies$parity + babies$age + babies$height + babies$weight + babies$smoke + 
          babies$gestation:babies$parity + 
          babies$gestation:babies$age + 
          babies$gestation:babies$height + 
          babies$gestation:babies$weight + 
          babies$gestation:babies$smoke +
          babies$parity:babies$age + 
          babies$parity:babies$height + 
          babies$parity:babies$weight + 
          babies$parity:babies$smoke + 
          babies$age:babies$height + 
          babies$age:babies$weight + 
          babies$age:babies$smoke + 
          babies$height:babies$weight + 
          babies$height:babies$smoke + 
          babies$weight:babies$smoke + 
          babies$gestation:babies$parity:babies$age +
          babies$gestation:babies$parity:babies$height +
          babies$gestation:babies$parity:babies$weight + 
          babies$gestation:babies$parity:babies$smoke + 
          babies$gestation:babies$age:babies$height +
          babies$gestation:babies$age:babies$weight +
          babies$gestation:babies$age:babies$smoke +
          babies$gestation:babies$height:babies$weight +
          babies$gestation:babies$height:babies$smoke +
          babies$gestation:babies$weight:babies$smoke,
          data=babies)
anova(m6,m7)

m8 = lm(babies$bwt ~ babies$gestation + babies$parity + babies$age + babies$height + babies$weight + babies$smoke + 
          babies$gestation:babies$parity + 
          babies$gestation:babies$age + 
          babies$gestation:babies$height + 
          babies$gestation:babies$weight + 
          babies$gestation:babies$smoke +
          babies$parity:babies$age + 
          babies$parity:babies$height + 
          babies$parity:babies$weight + 
          babies$parity:babies$smoke + 
          babies$age:babies$height + 
          babies$age:babies$weight + 
          babies$age:babies$smoke + 
          babies$height:babies$weight + 
          babies$height:babies$smoke + 
          babies$weight:babies$smoke + 
          babies$gestation:babies$parity:babies$age +
          babies$gestation:babies$parity:babies$height +
          babies$gestation:babies$parity:babies$weight + 
          babies$gestation:babies$parity:babies$smoke + 
          babies$gestation:babies$age:babies$height +
          babies$gestation:babies$age:babies$weight +
          babies$gestation:babies$age:babies$smoke +
          babies$gestation:babies$height:babies$weight +
          babies$gestation:babies$height:babies$smoke,
          data=babies)
anova(m7,m8) 
#tem diferena estatstica
#modelo complexo (m7)  melhor do que o mais simples (m8)
#Tentando simplificar o modelo vendo quais interaes podem ser retiradas
summary(m7)

m9 = lm(babies$bwt ~ babies$gestation + babies$parity + babies$age + babies$height + babies$weight + babies$smoke + 
          babies$gestation:babies$parity + 
          babies$gestation:babies$age + 
          babies$gestation:babies$height + 
          babies$gestation:babies$weight + 
          babies$gestation:babies$smoke +
          babies$parity:babies$age + 
          babies$parity:babies$height + 
          babies$parity:babies$weight + 
          babies$parity:babies$smoke + 
          babies$age:babies$height + 
          babies$age:babies$weight + 
          babies$age:babies$smoke + 
          babies$height:babies$weight + 
          babies$height:babies$smoke + 
          babies$weight:babies$smoke + 
          babies$gestation:babies$parity:babies$age +
          babies$gestation:babies$parity:babies$height +
          babies$gestation:babies$parity:babies$weight + 
          babies$gestation:babies$parity:babies$smoke + 
          babies$gestation:babies$age:babies$height +
          babies$gestation:babies$age:babies$weight +
          babies$gestation:babies$age:babies$smoke +
          babies$gestation:babies$height:babies$weight +
          babies$gestation:babies$weight:babies$smoke,
        data=babies)
anova(m7,m9)
summary(m9)

m10 = lm(babies$bwt ~ babies$gestation + babies$parity + babies$age + babies$height + babies$weight + babies$smoke + 
                babies$gestation:babies$parity + 
                babies$gestation:babies$age + 
                babies$gestation:babies$height + 
                babies$gestation:babies$weight + 
                babies$gestation:babies$smoke +
                babies$parity:babies$age + 
                babies$parity:babies$height + 
                babies$parity:babies$weight + 
                babies$parity:babies$smoke + 
                babies$age:babies$height + 
                babies$age:babies$weight + 
                babies$age:babies$smoke + 
                babies$height:babies$weight + 
                babies$height:babies$smoke + 
                babies$weight:babies$smoke + 
                babies$gestation:babies$parity:babies$age +
                babies$gestation:babies$parity:babies$height +
                babies$gestation:babies$parity:babies$weight + 
                babies$gestation:babies$parity:babies$smoke + 
                babies$gestation:babies$age:babies$height +
                babies$gestation:babies$age:babies$weight +
                babies$gestation:babies$age:babies$smoke +
                babies$gestation:babies$weight:babies$smoke,
              data=babies)
anova(m9,m10)
summary(m10)

m11 = lm(babies$bwt ~ babies$gestation + babies$parity + babies$age + babies$height + babies$weight + babies$smoke + 
           babies$gestation:babies$parity + 
           babies$gestation:babies$age + 
           babies$gestation:babies$height + 
           babies$gestation:babies$weight + 
           babies$gestation:babies$smoke +
           babies$parity:babies$age + 
           babies$parity:babies$height + 
           babies$parity:babies$weight + 
           babies$parity:babies$smoke + 
           babies$age:babies$height + 
           babies$age:babies$weight + 
           babies$age:babies$smoke + 
           babies$height:babies$weight + 
           babies$height:babies$smoke + 
           babies$weight:babies$smoke + 
           babies$gestation:babies$parity:babies$age +
           babies$gestation:babies$parity:babies$height +
           babies$gestation:babies$parity:babies$weight + 
           babies$gestation:babies$parity:babies$smoke + 
           babies$gestation:babies$age:babies$height +
           babies$gestation:babies$age:babies$smoke +
           babies$gestation:babies$weight:babies$smoke,
         data=babies)
anova(m10,m11)
summary(m11)

m12 = lm(babies$bwt ~ babies$gestation + babies$parity + babies$age + babies$height + babies$weight + babies$smoke + 
           babies$gestation:babies$parity + 
           babies$gestation:babies$age + 
           babies$gestation:babies$height + 
           babies$gestation:babies$weight + 
           babies$gestation:babies$smoke +
           babies$parity:babies$age + 
           babies$parity:babies$height + 
           babies$parity:babies$weight + 
           babies$parity:babies$smoke + 
           babies$age:babies$height + 
           babies$age:babies$weight + 
           babies$age:babies$smoke + 
           babies$height:babies$weight + 
           babies$height:babies$smoke + 
           babies$weight:babies$smoke + 
           babies$gestation:babies$parity:babies$age +
           babies$gestation:babies$parity:babies$height +
           babies$gestation:babies$parity:babies$weight + 
           babies$gestation:babies$parity:babies$smoke + 
           babies$gestation:babies$age:babies$smoke +
           babies$gestation:babies$weight:babies$smoke,
         data=babies)
anova(m11,m12)
summary(m12)

m13 = lm(babies$bwt ~ babies$gestation + babies$parity + babies$age + babies$height + babies$weight + babies$smoke + 
           babies$gestation:babies$parity + 
           babies$gestation:babies$age + 
           babies$gestation:babies$height + 
           babies$gestation:babies$weight + 
           babies$gestation:babies$smoke +
           babies$parity:babies$age + 
           babies$parity:babies$height + 
           babies$parity:babies$weight + 
           babies$parity:babies$smoke + 
           babies$age:babies$height + 
           babies$age:babies$weight + 
           babies$age:babies$smoke + 
           babies$height:babies$weight + 
           babies$height:babies$smoke + 
           babies$weight:babies$smoke + 
           babies$gestation:babies$parity:babies$age +
           babies$gestation:babies$parity:babies$height +
           babies$gestation:babies$parity:babies$weight + 
           babies$gestation:babies$age:babies$smoke +
           babies$gestation:babies$weight:babies$smoke,
         data=babies)
anova(m12,m13)
summary(m13)

m14 = lm(babies$bwt ~ babies$gestation + babies$parity + babies$age + babies$height + babies$weight + babies$smoke + 
           babies$gestation:babies$parity + 
           babies$gestation:babies$age + 
           babies$gestation:babies$height + 
           babies$gestation:babies$weight + 
           babies$gestation:babies$smoke +
           babies$parity:babies$age + 
           babies$parity:babies$height + 
           babies$parity:babies$weight + 
           babies$parity:babies$smoke + 
           babies$age:babies$height + 
           babies$age:babies$weight + 
           babies$age:babies$smoke + 
           babies$height:babies$weight + 
           babies$height:babies$smoke + 
           babies$weight:babies$smoke + 
           babies$gestation:babies$parity:babies$height +
           babies$gestation:babies$parity:babies$weight + 
           babies$gestation:babies$age:babies$smoke +
           babies$gestation:babies$weight:babies$smoke,
         data=babies)
anova(m13,m14)
summary(m14)

m15 = lm(babies$bwt ~ babies$gestation + babies$parity + babies$age + babies$height + babies$weight + babies$smoke + 
           babies$gestation:babies$parity + 
           babies$gestation:babies$age + 
           babies$gestation:babies$height + 
           babies$gestation:babies$weight + 
           babies$gestation:babies$smoke +
           babies$parity:babies$age + 
           babies$parity:babies$height + 
           babies$parity:babies$weight + 
           babies$parity:babies$smoke + 
           babies$age:babies$height + 
           babies$age:babies$weight + 
           babies$age:babies$smoke + 
           babies$height:babies$weight + 
           babies$weight:babies$smoke + 
           babies$gestation:babies$parity:babies$height +
           babies$gestation:babies$parity:babies$weight + 
           babies$gestation:babies$age:babies$smoke +
           babies$gestation:babies$weight:babies$smoke,
         data=babies)
anova(m14,m15)
summary(m15)

m16 =lm(babies$bwt ~ babies$gestation + babies$parity + babies$age + babies$height + babies$weight + babies$smoke + 
     babies$gestation:babies$parity + 
     babies$gestation:babies$age + 
     babies$gestation:babies$height + 
     babies$gestation:babies$weight + 
     babies$gestation:babies$smoke +
     babies$parity:babies$age + 
     babies$parity:babies$height + 
     babies$parity:babies$weight + 
     babies$parity:babies$smoke + 
     babies$age:babies$height + 
     babies$age:babies$weight + 
     babies$age:babies$smoke + 
     babies$weight:babies$smoke + 
     babies$gestation:babies$parity:babies$height +
     babies$gestation:babies$parity:babies$weight + 
     babies$gestation:babies$age:babies$smoke +
     babies$gestation:babies$weight:babies$smoke,
   data=babies)
anova(m15,m16)
summary(m16)

m17 = lm(babies$bwt ~ babies$gestation + babies$parity + babies$age + babies$height + babies$weight + babies$smoke + 
           babies$gestation:babies$parity + 
           babies$gestation:babies$age + 
           babies$gestation:babies$height + 
           babies$gestation:babies$weight + 
           babies$gestation:babies$smoke +
           babies$parity:babies$age + 
           babies$parity:babies$height + 
           babies$parity:babies$weight + 
           babies$parity:babies$smoke + 
           babies$age:babies$height + 
           babies$age:babies$smoke + 
           babies$weight:babies$smoke + 
           babies$gestation:babies$parity:babies$height +
           babies$gestation:babies$parity:babies$weight + 
           babies$gestation:babies$age:babies$smoke +
           babies$gestation:babies$weight:babies$smoke,
         data=babies)
anova(m16,m17)
summary(m17)

m18 = lm(babies$bwt ~ babies$gestation + babies$parity + babies$age + babies$height + babies$weight + babies$smoke + 
           babies$gestation:babies$parity + 
           babies$gestation:babies$age + 
           babies$gestation:babies$height + 
           babies$gestation:babies$weight + 
           babies$gestation:babies$smoke +
           babies$parity:babies$age + 
           babies$parity:babies$height + 
           babies$parity:babies$weight + 
           babies$parity:babies$smoke + 
           babies$age:babies$smoke + 
           babies$weight:babies$smoke + 
           babies$gestation:babies$parity:babies$height +
           babies$gestation:babies$parity:babies$weight + 
           babies$gestation:babies$age:babies$smoke +
           babies$gestation:babies$weight:babies$smoke,
         data=babies)
anova(m17,m18)
summary(m18)

m19 = lm(babies$bwt ~ babies$gestation + babies$parity + babies$age + babies$height + babies$weight + babies$smoke + 
           babies$gestation:babies$parity + 
           babies$gestation:babies$age + 
           babies$gestation:babies$height + 
           babies$gestation:babies$weight + 
           babies$gestation:babies$smoke +
           babies$parity:babies$age + 
           babies$parity:babies$height + 
           babies$parity:babies$weight + 
           babies$age:babies$smoke + 
           babies$weight:babies$smoke + 
           babies$gestation:babies$parity:babies$height +
           babies$gestation:babies$parity:babies$weight + 
           babies$gestation:babies$age:babies$smoke +
           babies$gestation:babies$weight:babies$smoke,
         data=babies)
anova(m18,m19)
summary(m19)

m20 = lm(babies$bwt ~ babies$gestation + babies$parity + babies$age + babies$height + babies$weight + babies$smoke + 
     babies$gestation:babies$parity + 
     babies$gestation:babies$age + 
     babies$gestation:babies$height + 
     babies$gestation:babies$weight + 
     babies$gestation:babies$smoke +
     babies$parity:babies$height + 
     babies$parity:babies$weight + 
     babies$age:babies$smoke + 
     babies$weight:babies$smoke + 
     babies$gestation:babies$parity:babies$height +
     babies$gestation:babies$parity:babies$weight + 
     babies$gestation:babies$age:babies$smoke +
     babies$gestation:babies$weight:babies$smoke,
   data=babies)
anova(m19,m20)
summary(m20)

m21 = lm(babies$bwt ~ babies$gestation + babies$parity + babies$age + babies$height + babies$weight + babies$smoke + 
           babies$gestation:babies$parity + 
           babies$gestation:babies$age + 
           babies$gestation:babies$height + 
           babies$gestation:babies$smoke +
           babies$parity:babies$height + 
           babies$parity:babies$weight + 
           babies$age:babies$smoke + 
           babies$weight:babies$smoke + 
           babies$gestation:babies$parity:babies$height +
           babies$gestation:babies$parity:babies$weight + 
           babies$gestation:babies$age:babies$smoke +
           babies$gestation:babies$weight:babies$smoke,
         data=babies)
anova(m20,m21)
summary(m21)

#O modelo 21  o modelo mnimo adequado, pois no h mais interaes no significativas que possam ser retiradas do modelo
#Testando: tirando uma interao qualquer que  significativa para ver se o teste acusa diferena estatstica entre modelos
m.teste = lm(babies$bwt ~ babies$gestation + babies$parity + babies$age + babies$height + babies$weight + babies$smoke + 
           babies$gestation:babies$parity + 
           babies$gestation:babies$age + 
           babies$gestation:babies$smoke +
           babies$parity:babies$height + 
           babies$parity:babies$weight + 
           babies$age:babies$smoke + 
           babies$weight:babies$smoke + 
           babies$gestation:babies$parity:babies$height +
           babies$gestation:babies$parity:babies$weight + 
           babies$gestation:babies$age:babies$smoke +
           babies$gestation:babies$weight:babies$smoke,
         data=babies)
anova(m21,m.teste)


#Ok, tem diferena. Portanto, o modelo 21 parece ser mesmo o modelo mnimo adequado para explicar a massa dos bebs!
#Comparando o modelo 21 com o modelo nulo
m0 = lm(babies$bwt ~1,data=babies)
anova(m0,m21)
anova(m21)

#Diagnstico do modelo21
par(mfrow=c(2,2),mar=c(4,4,2,2),cex.lab=1.2,cex.axis=1.2,las=1)
plot(m21)
