#Exercicios
#ler os dados
babies = read.table("babies.csv", sep = "\t", dec = ".", header = T)
str(babies)
head(babies)
tail(babies)
summary(babies)
#tirando dados faltantes
bbs = babies[babies$gestation!=999,]
bbs
bbs=bbs[bbs$bwt!=999,]
bbs
bbs=bbs[bbs$parity!=9,]
bbs=bbs[bbs$age!=99,]
bbs=bbs[bbs$height!=99,]
bbs=bbs[bbs$weight!=999,]
bbs=bbs[bbs$smoke!=9,]
str(bbs)
head(bbs)
tail(bbs)
summary(bbs)
#modelo linear peso ~ tempo de gestacao
lm1 = lm(bbs$bwt~bbs$gestation)
summary(lm1)

plot(bwt~gestation, data = bbs)
abline(lm1,col = "red")
#criar um objeto para estimar os valores do intervalo de confiana
x = seq(from = min(bbs$gestation), to  = max(bbs$gestation), length.out = 100)
s2 = var(bbs$bwt)
med=mean(bbs$gestation)
n = length(bbs$gestation)
dq = sum((x - mean(bbs$gestation))^2)
se.y <- sqrt(s2*(1/n+((x-med)^2)/dq))
se.y

coef = coef(lm1)
coef

y = coef[1]+coef[2]*x
y

gl = n-2 #graus de liberdade
gl

#Multiplicando o erro padrao da previsao do modelo pelo valor t de Student.
quan.t = qt(0.95,gl)
quan.t

#intervalos de confianca
IC1 = y + (se.y*quan.t)
IC1

IC2 = y - (se.y*quan.t)
IC2
#GRAFICO DO MODELO COM IC DE 95%.
x11()
plot(bwt~gestation, data=bbs)
abline(lm1, col="red",lwd=2)
curve((coef[1]+(coef[2]*x))+(se.y*quan.t),add=T,col="blue",lwd=2,n=100)
curve((coef[1]+(coef[2]*x))-(se.y*quan.t),add=T,col="blue",lwd=2,n=100)
#ou 
#IC = confint(lm1,level = 0.975)
#IC
#?confint()


#Ex2
install.packages("UsingR")
library(UsingR)
galileu = galileo
str(galileu)
head(galileu)
tail(galileu)
summary(galileu)
x11()
plot(galileu)
lm1 = lm(galileu$h.d~galileu$init.h)
summary(lm1)
abline(lm1, col="red",lty=2)
lm2 = update(lm1,.~. +I(galileu$init.h^2))
summary(lm2)
cf2 = coef(lm2)
cf2
curve(cf2[1]+cf2[2]*x+cf2[3]*x^2, add=T, lty=2, col="blue")
anova(lm1,lm2)
lm3 =  update(lm1,.~. +I(galileu$init.h^3))
summary(lm3)
cf3=coef(lm3)
cf3
curve(cf3[1]+cf3[2]*x+cf3[3]*x^3, add=T, lty=2, col="orange")
anova(lm2,lm3)


#Ex3
library(UsingR)
dados = bbs
str(dados)
head(dados)
tail(dados)
summary(dados)

#substituio dos faltantes feita no ex1
#bwt	Massa ao nascer em onas (999 = ignorado)
#gestation	Durao da gestao em dias (999 = ignorado)
#parity	0 = primeira gestao, 1 = no  a primeira gestao (9 = ignorado)
#age	idade da me em anos (99 = ignorado)
#height	altura da me em polegadas (99 = ignorado)
#weight	Massa da me antes da gestao, em libras (999 = ignorado)
#smoke	A me  fumante: 0 = no no momento, 1= sim no momento, 9 = ignorado
plot(dados)
#pelo plot smoke e parity parecem no influenciar mto as outras variveis (poderiam ser retirados do modelo)
#faz sentido comear das interaes duplas pelo plot 
m1 = lm(bwt~gestation + parity + age + height + weight + smoke + gestation:parity +gestation:age+gestation:height+gestation:weight+gestation:smoke+parity:age +parity:height +parity:weight +parity:smoke+
        age:height + age:weight + age:smoke+ height:weight + height:smoke + weight:smoke+gestation:parity:age+ gestation:parity:height +gestation:parity:weight +gestation:parity:smoke+parity:age:height+parity:age:weight+parity:age:smoke+age:height:weight +age:height:smoke+height:weight:smoke, data = dados)
summary(m1)
m2=lm(bwt~gestation + parity + age + height + weight + smoke + gestation:parity +gestation:age+gestation:height+gestation:weight+gestation:smoke+parity:age +parity:height +parity:weight +parity:smoke+
        age:height + age:weight + age:smoke+ height:weight + height:smoke + weight:smoke, data = dados)
summary(m2)
anova(m1,m2)
m3=lm(bwt~gestation + parity + age + height + weight + smoke + gestation:parity +gestation:age+gestation:height+gestation:weight+gestation:smoke+parity:age +parity:height +parity:weight +parity:smoke+
        age:height + age:weight + age:smoke+ height:weight + height:smoke, data = dados)
anova(m2,m3)
m4=lm(bwt~gestation + parity + age + height + weight + smoke + gestation:parity +gestation:age+gestation:height+gestation:weight+gestation:smoke+parity:age +parity:height +parity:smoke+
        age:height + age:weight + age:smoke+ height:weight + height:smoke + weight:smoke, data = dados)
anova(m3,m4)
summary(m4)
m5=lm(bwt~gestation + parity + age + height + weight + smoke + gestation:parity +gestation:age+gestation:height+gestation:weight+gestation:smoke+parity:age +parity:height+ age:weight + age:smoke, data = dados)
summary(m5)
anova(m4,m5)
m6=lm(bwt~gestation + parity + age + height + weight + smoke + gestation:parity +gestation:age+gestation:height+gestation:weight+gestation:smoke, data = dados)
summary(m6)
anova(m5,m6)
m7= lm(bwt~gestation + parity + age + height + weight + smoke + gestation:parity +gestation:age+gestation:weight+gestation:smoke, data = dados)
summary(m7)
anova(m6,m7)
m8=lm(bwt~gestation + parity + age + height + weight + smoke + gestation:parity +gestation:age+gestation:smoke, data = dados)
summary(m8)
anova(m7,m8)
#modelo mnimo adequado  o m m8!
#m8=lm(bwt~gestation + parity + age + height + weight + smoke + gestation:parity +gestation:age+gestation:smoke, data = dados)


